/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "Compiler_use.h"
#include "../include/string_utils.h"

int main (int argc, char* argv[])
{  obst_init (argc, argv);

   CText          ct = CText::create          (TEMP_CONTAINER, tmp_str("ct"));
   PascalText     pt = PascalText::create     (TEMP_CONTAINER, tmp_str("pt"));

   CCompiler      cc = CCompiler::create      (TEMP_CONTAINER, tmp_str ("cc"));
   PascalCompiler pc = PascalCompiler::create (TEMP_CONTAINER, tmp_str ("pc"));

   ct.compile (cc);   
   pt.compile (pc);

   // ct.compile (pc); // what happens ?

   return 0;
}
