/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "dir_use.h"
#include "../UnixFile/UnixFile_use.h"
#include "../include/string_utils.h"

int main (int argc, char* argv[])
{  obst_init (argc, argv);

   sos_Directory root_dir = sos_Directory::root();
   sos_String file_name   = sos_String::create (TEMP_CONTAINER);

   file_name.assign_Cstring ("pretty file");

   sos_Object obj = root_dir [file_name];

   UnixFile f1 = UnixFile::make (obj);
 
   cout << "I got the file with the name " << f1.get_name() << ".\n"
	<< "Its size is " << f1.get_size() << "\n";;
   return 0;
}
  
