/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "UnixFile_use.h"

int main (int argc, char *argv[])
{  obst_init (argc, argv);

   UnixFile f1 = UnixFile::create (TEMP_CONTAINER);
   UnixFile f2 = UnixFile::create (TEMP_CONTAINER);

   f1.set_size(100);
   cout << "The size of f1 is " << f1.get_size() << "\n";

   f2.set_size(50);
   cout << "The size of f2 is " << f2.get_size() << "\n";

   f1.append(f2);
   cout << "The size of f1 is now " << f1.get_size() << "\n";

   return 0;
}
  
