
#define yylineno	cfe_yylineno
#define yyin		cfe_yyin
#define yyreds		cfe_yyreds
#define yyout		cfe_yyout
#define yyparse		cfe_yyparse
#define yylex		cfe_yylex
#define yyerror		cfe_yyerror
#define yylval		cfe_yylval
#define yyunput         cfe_yyunput
#define yyinput         cfe_yyinput
#define yyoutput        cfe_yyoutput
#define yyval		cfe_yyval
#define yys		cfe_yys
#define yyv		cfe_yyv
#define yypv		cfe_yypv
# define name_tok 257
# define number_tok 258
# define abstract_tok 259
# define class_tok 260
# define definite_tok 261
# define enum_tok 262
# define extern_tok 263
# define friend_tok 264
# define local_tok 265
# define operator_tok 266
# define private_tok 267
# define protected_tok 268
# define public_tok 269
# define schema_tok 270
# define set_tok 271
# define static_tok 272
# define typedef_tok 273
# define union_tok 274
# define with_tok 275
# define l_abr_tok 276
# define r_abr_tok 277
# define l_br_tok 278
# define r_br_tok 279
# define l_brc_tok 280
# define r_brc_tok 281
# define l_par_tok 282
# define r_par_tok 283
# define ampersand_tok 284
# define ampersand_assign_tok 285
# define and_tok 286
# define assign_tok 287
# define bar_tok 288
# define bar_assign_tok 289
# define circumflex_tok 290
# define circumflex_assign_tok 291
# define colon_tok 292
# define comma_tok 293
# define equal_tok 294
# define exclam_tok 295
# define greater_equal_tok 296
# define less_equal_tok 297
# define minus_tok 298
# define minus_assign_tok 299
# define not_equal_tok 300
# define or_tok 301
# define percent_tok 302
# define percent_assign_tok 303
# define plus_tok 304
# define plus_assign_tok 305
# define rshift_assign_tok 306
# define lshift_assign_tok 307
# define slash_tok 308
# define slash_assign_tok 309
# define star_tok 310
# define star_assign_tok 311
# define semicolon_tok 312

# line 118 "src/cfe/cfe.y"

#define OBST_IMP_STRINGOP
#define OBST_IMP_MALLOC
#include "obst_stdinc.h"
#include "_obst_config.h"
#include "obst_progstd.h"

#include "smg.h"
#include "cfe_err.h"
#include "mta_use.h"
#include "cfe.h"

typedef union {
	  sos_Bool				b;
	  sos_Int				i;
	  sos_Cstring				s;
          sos_Import_List			imp;
          sos_String				str;
          sos_String_List			str_l;
          sos_Enum_type				etd;
          sos_Class_type			ctd;
          sos_Gen_param				gp;
          sos_Gen_param_List			gp_l;
          sos_Param				par;
          sos_Param_List			par_l;
	  sos_Method_kind			mk;
          sos_Method_List			md_l;
          sos_Method				md;
          sos_Union_type			utd;
          sos_Typedef_type			ttd;
          sos_Extern_type			xtd;
	  sos_Type_descr			td;
	  sos_Type_descr_List			td_l;
	  sos_Type_List				tp_l;
	  sos_Super_class_List			sc_l;
	  sos_Super_class			sc;
          sos_Expr				exp;
          sos_Int_expr				ie;
          sos_Identifier			id;
          sos_Expr_List				exp_l;
        } YYSTYPE;

static sos_Type_descr 	   cfe_fct_or_comp_type;
static sos_Bool		   cfe_is_full_type,
                           cfe_class_is_abstract,
	                   cfe_method_is_abstract,
		           cfe_method_is_definite, 
		           cfe_method_is_local, 
		           cfe_method_is_operator,
                           cfe_method_is_static, 
                           cfe_method_is_value;
static sos_Method_kind 	   cfe_method_kind,
                           cfe_set_method_kind;
static sos_Int 		   cfe_component_offset;
static sos_Type_descr_List cfe_gen_insts;

sos_Class_type cfe_ct;

#include "cfe_lex.h"
extern _mta_use_err_USE;

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;

# line 184 "src/cfe/cfe.y"
# define YYERRCODE 256

# line 816 "src/cfe/cfe.y"


static void yyerror (err_msg s) {cfe_error (err_USE, s);}

static void yyecho () {if (cfe_echo_flag) ECHO;}
static int yyexca[] ={
-1, 0,
	270, 1,
	275, 1,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 24,
	259, 13,
	260, 13,
	262, 13,
	263, 13,
	273, 13,
	274, 13,
	281, 13,
	-2, 0,
-1, 136,
	257, 59,
	271, 59,
	-2, 0,
-1, 162,
	282, 146,
	-2, 143,
	};
# define YYNPROD 149
# define YYLAST 331
static int yyact[]={

   179,   178,   201,   216,   208,    18,   200,    50,   184,   196,
   187,   189,   186,   197,   185,   195,    42,    41,   180,   171,
   183,   182,   177,   191,   181,   188,   175,   194,   176,   190,
   198,   199,   174,   193,   173,   192,    17,    19,   170,   153,
   143,   134,    87,   149,   101,   150,   204,    82,   145,   153,
    68,   146,   147,   148,   102,    18,   151,    67,    88,    83,
    66,   133,    69,   116,   214,   100,    12,    89,   114,   154,
    39,   104,    12,    35,    38,   212,    67,   132,    74,   154,
    13,    86,   117,    57,    34,    37,    13,   135,   115,     7,
    64,   213,    27,    53,    24,   210,   114,    52,    93,   211,
   118,    71,    22,     6,    12,    12,   124,    12,    12,   217,
   146,   147,   148,   163,     9,     9,   167,    47,    13,    13,
    65,    13,    13,    26,     3,   142,    45,   161,    60,    85,
   152,    11,   113,    10,   120,   123,    58,   107,    95,    15,
    80,     5,    55,    14,    23,   158,   144,    59,   203,    16,
   165,   141,   156,   140,   139,   136,   131,   125,    21,   105,
    92,    78,    63,    43,    36,    28,     8,    15,    25,    15,
    15,    46,    20,    48,    49,     4,    15,    40,     2,    15,
    51,     1,    44,    54,   103,    15,   110,   121,   122,    62,
   128,   127,   205,    72,   106,   108,    94,    84,   172,   160,
   157,    15,   155,    15,    79,    77,    70,    81,    56,    33,
    32,    31,    73,    99,    30,    75,    29,    61,    76,     0,
    15,     0,     0,     0,    81,     0,     0,   109,     0,    97,
     0,    91,    90,     0,    96,    15,     0,    98,     0,   112,
     0,   111,     0,   109,     0,   119,    15,     0,     0,    15,
    96,     0,   129,     0,   126,   130,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    15,     0,   164,   137,     0,
     0,     0,   162,     0,     0,     0,   159,     0,     0,     0,
     0,   168,     0,     0,     0,   138,     0,   169,     0,     0,
     0,     0,   166,     0,   206,     0,   207,   202,   164,   209,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   215 };
static int yypact[]={

  -132, -1000,  -172, -1000,  -181, -1000,  -149,  -150,  -257,  -275,
 -1000, -1000, -1000, -1000, -1000, -1000,  -173,  -150, -1000, -1000,
  -186, -1000,  -148, -1000,  -133,  -189, -1000,  -307, -1000, -1000,
 -1000, -1000,  -295,  -296,  -150,  -150,  -143,  -150,  -150, -1000,
 -1000, -1000, -1000,  -305,  -150,  -179,  -187,  -150, -1000,  -199,
 -1000, -1000,  -150,  -150, -1000,  -190, -1000,  -138,  -217, -1000,
 -1000,  -231, -1000,  -175,  -150,  -205, -1000,  -150,  -307,  -150,
 -1000,  -150,  -234, -1000, -1000, -1000, -1000, -1000,  -201,  -235,
 -1000,  -225,  -307,  -150, -1000, -1000,  -185, -1000,  -150,  -150,
 -1000, -1000,  -227, -1000,  -239, -1000,  -213, -1000, -1000, -1000,
  -150, -1000,  -150,  -191, -1000,  -192,  -230, -1000,  -200,  -176,
 -1000, -1000,  -219, -1000,  -152, -1000,  -150,  -152,  -150, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -206,  -232, -1000,
  -236,  -194, -1000,  -152, -1000,  -307,  -216, -1000, -1000, -1000,
  -153, -1000, -1000, -1000,  -150,  -144, -1000, -1000, -1000, -1000,
  -226, -1000, -1000, -1000, -1000, -1000, -1000,  -201,  -274, -1000,
 -1000, -1000, -1000,  -276,  -219,  -247, -1000,  -150, -1000,  -308,
 -1000,  -150, -1000, -1000, -1000, -1000, -1000, -1000,  -182,  -177,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
  -208,  -188, -1000,  -228,  -157,  -309,  -179, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,  -162, -1000, -1000 };
static int yypgo[]={

     0,   131,   135,   126,   217,   216,   214,   213,   211,   210,
   209,   208,   206,   204,   140,   137,   125,   202,   200,   199,
   198,   197,   129,   196,   138,   132,   195,   147,   194,   193,
   192,   136,   134,   191,   190,   188,   187,   128,   186,   184,
   181,   178,   175,   172,   168,   149,   141,   166,   165,   164,
   162,   161,   160,   159,   157,   156,   155,   154,   153,   152,
   151,   150,   148,   146,   130,   145,   127,   142 };
static int yyr1[]={

     0,    41,    43,    40,    40,    42,    42,    47,    47,    46,
    46,    45,    45,    44,    44,    44,    48,    48,    48,    48,
    48,    48,     5,    50,    51,    52,    53,    54,     6,    49,
    49,    12,    12,    13,    13,    14,    14,    21,    21,     7,
     7,    28,    28,    15,    15,    55,    56,    55,    57,    57,
    57,    61,    57,    57,    58,    63,    63,    63,    63,    64,
    64,    64,    16,    16,    16,    62,    62,    17,    18,    18,
    19,    20,    20,    20,    20,    20,    20,    20,    20,    20,
    20,    20,    20,    20,    20,    20,    20,    20,    20,    20,
    20,    20,    20,    20,    20,    20,    20,    20,    20,    20,
    20,    20,    22,    22,    23,    23,    24,    24,    39,    39,
    25,    25,    59,    65,    65,    66,    60,    67,     8,     9,
    10,    11,    11,    26,    26,    27,    27,    30,    30,    33,
    33,    34,    34,    32,    32,    36,    35,    38,    37,    29,
    29,    31,    31,     3,     4,     4,     2,     1,     1 };
static int yyr2[]={

     0,     1,     1,    19,     2,     2,     8,     3,     7,     1,
     7,     0,     2,     0,     4,     2,     2,     2,     2,     4,
     4,     6,    13,     1,     1,     1,     1,     1,    31,     1,
     3,     1,     7,     3,     7,     3,     7,     1,     2,     1,
     5,     3,     7,     3,     9,     1,     1,     6,     4,     4,
     2,     1,     8,     2,     5,     3,     5,     3,     2,     0,
     3,     3,     3,     3,     3,     1,     7,     7,     3,     3,
     5,     3,     3,     3,     3,     3,     5,     5,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     5,     5,     5,     7,     3,     7,     9,     7,     1,     3,
     1,     5,     4,     2,     6,     5,     9,     1,    15,     7,
     7,     1,     7,     3,     3,     3,     3,     3,     3,     1,
     2,     3,     7,     3,     3,     3,     3,     9,     9,     3,
     7,     3,     7,     3,     3,     7,     3,     3,     3 };
static int yychk[]={

 -1000,   -40,   -41,   256,   -42,   -46,   275,   270,   -47,   263,
    -3,    -1,   257,   271,    -2,    -1,   -45,   293,   312,   312,
   -43,   -46,   275,    -3,   280,   -44,   256,   281,   -48,    -5,
    -6,    -8,    -9,   -10,   273,   262,   -49,   274,   263,   259,
   -45,   312,   312,   -37,   -27,    -3,    -2,   260,    -2,    -2,
   312,    -2,   276,   280,    -2,   -67,   -11,   282,   -31,   -27,
   -37,    -4,    -2,   -50,   280,   258,   277,   293,   281,   293,
   -12,   276,   -29,   -27,   283,   -27,   -45,    -2,   -51,   -13,
   -14,    -2,   281,   293,   -21,   -22,   282,   277,   293,   292,
   -45,   -27,   -52,   283,   -23,   -24,   -27,   -14,   -27,    -7,
   292,   283,   293,   -39,   284,   -53,   -28,   -15,   -26,    -3,
   -38,   -24,    -2,   -25,   287,   280,   293,   282,   276,   -25,
   -32,   -36,   -35,    -2,   258,   -54,   -15,   -33,   -34,   -32,
   -31,   -55,   283,   293,   277,   281,   -56,   -32,   -45,   -57,
   -58,   -60,   -16,   256,   -63,   264,   267,   268,   269,   259,
   261,   272,   -64,   265,   295,   -17,   -59,   -18,   -65,    -2,
   -19,   -66,    -1,   266,    -3,   -61,   -27,   260,   -64,   -22,
   312,   293,   -20,   310,   308,   302,   304,   298,   277,   276,
   294,   300,   297,   296,   284,   290,   288,   286,   301,   287,
   305,   299,   311,   309,   303,   291,   285,   289,   306,   307,
   282,   278,   -25,   -62,   293,   -30,    -3,   -37,   312,   -66,
   277,   276,   283,   279,   292,   -16,   312,   271 };
static int yydef[]={

    -2,    -2,     9,     4,     0,     5,     0,     0,    11,     0,
     7,   143,   147,   148,     2,   146,     9,     0,    12,    10,
     0,     6,     0,     8,    -2,    29,    15,    11,    14,    16,
    17,    18,     0,     0,     0,     0,     0,     0,     0,    30,
     3,    19,    20,   126,     0,   125,     0,     0,   117,   121,
    21,   119,     0,     0,    23,     0,   120,     0,     0,   141,
   126,     0,   144,    31,     0,     0,   138,     0,    11,     0,
    24,     0,     0,   139,   122,   142,    22,   145,    37,     0,
    33,    35,    11,     0,    25,    38,     0,    32,     0,     0,
   118,   140,    39,   102,     0,   104,   108,    34,    36,    26,
     0,   103,     0,   110,   109,     0,    40,    41,    43,   123,
   124,   105,   110,   107,     0,    27,     0,   129,     0,   106,
   111,   133,   134,   135,   136,    45,    42,     0,   130,   131,
     0,    46,    44,     0,   137,    11,    -2,   132,    28,    47,
     0,    50,    51,    53,     0,     0,    62,    63,    64,    55,
    59,    57,    58,    60,    61,    48,    49,     0,     0,    68,
    69,   113,    -2,     0,   110,    65,    54,     0,    56,     0,
   112,     0,    70,    71,    72,    73,    74,    75,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     0,     0,   115,     0,     0,     0,   127,   128,    67,   114,
    76,    77,   100,   101,    52,     0,   116,    66 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

static yytoktype yytoks[] =
{
	"name_tok",	257,
	"number_tok",	258,
	"abstract_tok",	259,
	"class_tok",	260,
	"definite_tok",	261,
	"enum_tok",	262,
	"extern_tok",	263,
	"friend_tok",	264,
	"local_tok",	265,
	"operator_tok",	266,
	"private_tok",	267,
	"protected_tok",	268,
	"public_tok",	269,
	"schema_tok",	270,
	"set_tok",	271,
	"static_tok",	272,
	"typedef_tok",	273,
	"union_tok",	274,
	"with_tok",	275,
	"l_abr_tok",	276,
	"r_abr_tok",	277,
	"l_br_tok",	278,
	"r_br_tok",	279,
	"l_brc_tok",	280,
	"r_brc_tok",	281,
	"l_par_tok",	282,
	"r_par_tok",	283,
	"ampersand_tok",	284,
	"ampersand_assign_tok",	285,
	"and_tok",	286,
	"assign_tok",	287,
	"bar_tok",	288,
	"bar_assign_tok",	289,
	"circumflex_tok",	290,
	"circumflex_assign_tok",	291,
	"colon_tok",	292,
	"comma_tok",	293,
	"equal_tok",	294,
	"exclam_tok",	295,
	"greater_equal_tok",	296,
	"less_equal_tok",	297,
	"minus_tok",	298,
	"minus_assign_tok",	299,
	"not_equal_tok",	300,
	"or_tok",	301,
	"percent_tok",	302,
	"percent_assign_tok",	303,
	"plus_tok",	304,
	"plus_assign_tok",	305,
	"rshift_assign_tok",	306,
	"lshift_assign_tok",	307,
	"slash_tok",	308,
	"slash_assign_tok",	309,
	"star_tok",	310,
	"star_assign_tok",	311,
	"semicolon_tok",	312,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"schema_module : /* empty */",
	"schema_module : imports schema_tok name",
	"schema_module : imports schema_tok name l_brc_tok type_declarations r_brc_tok opt_semicolon",
	"schema_module : error",
	"imports : extern_import",
	"imports : with_tok import_names opt_semicolon extern_import",
	"import_names : name1",
	"import_names : import_names comma_tok name1",
	"extern_import : /* empty */",
	"extern_import : with_tok extern_tok semicolon_tok",
	"opt_semicolon : /* empty */",
	"opt_semicolon : semicolon_tok",
	"type_declarations : /* empty */",
	"type_declarations : type_declarations type_declaration",
	"type_declarations : error",
	"type_declaration : enumeration_declaration",
	"type_declaration : class_declaration",
	"type_declaration : union_declaration",
	"type_declaration : typedef_declaration semicolon_tok",
	"type_declaration : extern_declaration semicolon_tok",
	"type_declaration : typedef_tok generic_instantiation semicolon_tok",
	"enumeration_declaration : enum_tok name l_brc_tok names_based_on_equal r_brc_tok opt_semicolon",
	"class_declaration : class_kind class_tok name",
	"class_declaration : class_kind class_tok name gen_params",
	"class_declaration : class_kind class_tok name gen_params opt_parameters",
	"class_declaration : class_kind class_tok name gen_params opt_parameters super_classes",
	"class_declaration : class_kind class_tok name gen_params opt_parameters super_classes l_brc_tok",
	"class_declaration : class_kind class_tok name gen_params opt_parameters super_classes l_brc_tok method_declarations r_brc_tok opt_semicolon",
	"class_kind : /* empty */",
	"class_kind : abstract_tok",
	"gen_params : /* empty */",
	"gen_params : l_abr_tok gen_params_1 r_abr_tok",
	"gen_params_1 : gen_param",
	"gen_params_1 : gen_params_1 comma_tok gen_param",
	"gen_param : name",
	"gen_param : name colon_tok type_name",
	"opt_parameters : /* empty */",
	"opt_parameters : parameters",
	"super_classes : /* empty */",
	"super_classes : colon_tok super_class_list",
	"super_class_list : super_class",
	"super_class_list : super_class_list comma_tok super_class",
	"super_class : super_class_type_name",
	"super_class : super_class_type_name l_par_tok exprs r_par_tok",
	"method_declarations : /* empty */",
	"method_declarations : method_declarations",
	"method_declarations : method_declarations method_declaration",
	"method_declaration : fct_or_comp_type function_method",
	"method_declaration : fct_or_comp_type comp_methods",
	"method_declaration : friend",
	"method_declaration : method_kind_spec",
	"method_declaration : method_kind_spec set_method_kind_spec colon_tok",
	"method_declaration : error",
	"fct_or_comp_type : fct_or_comp_kind type_name",
	"fct_or_comp_kind : abstract_tok",
	"fct_or_comp_kind : definite_tok local_or_value_spec",
	"fct_or_comp_kind : static_tok",
	"fct_or_comp_kind : local_or_value_spec",
	"local_or_value_spec : /* empty */",
	"local_or_value_spec : local_tok",
	"local_or_value_spec : exclam_tok",
	"method_kind_spec : private_tok",
	"method_kind_spec : protected_tok",
	"method_kind_spec : public_tok",
	"set_method_kind_spec : /* empty */",
	"set_method_kind_spec : comma_tok method_kind_spec set_tok",
	"function_method : function_name parameters semicolon_tok",
	"function_name : name",
	"function_name : operator",
	"operator : operator_tok operator_string",
	"operator_string : star_tok",
	"operator_string : slash_tok",
	"operator_string : percent_tok",
	"operator_string : plus_tok",
	"operator_string : minus_tok",
	"operator_string : r_abr_tok r_abr_tok",
	"operator_string : l_abr_tok l_abr_tok",
	"operator_string : r_abr_tok",
	"operator_string : l_abr_tok",
	"operator_string : equal_tok",
	"operator_string : not_equal_tok",
	"operator_string : less_equal_tok",
	"operator_string : greater_equal_tok",
	"operator_string : ampersand_tok",
	"operator_string : circumflex_tok",
	"operator_string : bar_tok",
	"operator_string : and_tok",
	"operator_string : or_tok",
	"operator_string : assign_tok",
	"operator_string : plus_assign_tok",
	"operator_string : minus_assign_tok",
	"operator_string : star_assign_tok",
	"operator_string : slash_assign_tok",
	"operator_string : percent_assign_tok",
	"operator_string : circumflex_assign_tok",
	"operator_string : ampersand_assign_tok",
	"operator_string : bar_assign_tok",
	"operator_string : rshift_assign_tok",
	"operator_string : lshift_assign_tok",
	"operator_string : l_par_tok r_par_tok",
	"operator_string : l_br_tok r_br_tok",
	"parameters : l_par_tok r_par_tok",
	"parameters : l_par_tok parameters_1 r_par_tok",
	"parameters_1 : parameter",
	"parameters_1 : parameters_1 comma_tok parameter",
	"parameter : type_name reference name default_expr",
	"parameter : type_name reference default_expr",
	"reference : /* empty */",
	"reference : ampersand_tok",
	"default_expr : /* empty */",
	"default_expr : assign_tok expr",
	"comp_methods : comp_names semicolon_tok",
	"comp_names : comp_name",
	"comp_names : comp_names comma_tok comp_name",
	"comp_name : name1 default_expr",
	"friend : friend_tok class_tok type_name1 semicolon_tok",
	"union_declaration : union_tok name",
	"union_declaration : union_tok name l_brc_tok types r_brc_tok opt_semicolon",
	"typedef_declaration : typedef_tok type_name name",
	"extern_declaration : extern_tok name extern_size",
	"extern_size : /* empty */",
	"extern_size : l_par_tok number_tok r_par_tok",
	"super_class_type_name : name1",
	"super_class_type_name : super_class_generic_instantiation",
	"type_name : name1",
	"type_name : generic_instantiation",
	"type_name1 : name1",
	"type_name1 : generic_instantiation",
	"exprs : /* empty */",
	"exprs : exprs1",
	"exprs1 : expr",
	"exprs1 : exprs1 comma_tok expr",
	"expr : identifier",
	"expr : number",
	"identifier : name",
	"number : number_tok",
	"super_class_generic_instantiation : name1 l_abr_tok type_names r_abr_tok",
	"generic_instantiation : name1 l_abr_tok type_names r_abr_tok",
	"types : type_name",
	"types : types comma_tok type_name",
	"type_names : type_name",
	"type_names : type_names comma_tok type_name",
	"name1 : name_tok_or_keyword",
	"names_based_on_equal : name",
	"names_based_on_equal : names_based_on_equal comma_tok name",
	"name : name_tok_or_keyword",
	"name_tok_or_keyword : name_tok",
	"name_tok_or_keyword : set_tok",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free((char*)yys); free((char*)yyv); return(0); }
#define YYABORT		{ free((char*)yys); free((char*)yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
extern int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

extern int yynerrs;			/* number of errors */

extern int yyerrflag;			/* error recovery flag */
extern int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 187 "src/cfe/cfe.y"
{  _mta_use_err_USE = TRUE; // only produce err_USE-errors
	cfe_schema    = sos_Schema_module::create_schema (sos_String::create
					(TEMP_CONTAINER, "new_name")
					/*sos_String::make(NO_OBJECT)*/, TRUE);
#ifdef OBST_HAVE_PROT
	// do not generate protocol information during compile
	sos_ModifHistory::set_gen_prot(cfe_schema, FALSE);
#endif
	cfe_cnt       = cfe_schema.container();
	cfe_ct        = sos_Class_type::make (NO_OBJECT);
	cfe_gen_insts = sos_Type_descr_List::create (TEMP_CONTAINER);
     } break;
case 2:
# line 200 "src/cfe/cfe.y"
{  cfe_schema.modify_name (yypvt[-0].str, TRUE);
        cfe_init (yypvt[-0].str);
     } break;
case 3:
# line 204 "src/cfe/cfe.y"
{  cfe_complete_forward_insts ();
	cfe_check_schema ();
        cfe_check_generic_instantiations (cfe_gen_insts);
        cfe_finalize();
     } break;
case 7:
# line 219 "src/cfe/cfe.y"
{  cfe_import_module (yypvt[-0].str);
     } break;
case 8:
# line 222 "src/cfe/cfe.y"
{  cfe_import_module (yypvt[-0].str);
     } break;
case 9:
# line 227 "src/cfe/cfe.y"
{  cfe_schema.set_has_external_import (FALSE);  } break;
case 10:
# line 229 "src/cfe/cfe.y"
{  cfe_schema.set_has_external_import (TRUE);  } break;
case 22:
# line 254 "src/cfe/cfe.y"
{  cfe_check_type (yypvt[-4].str);
	/* Use temporary variable e instead of $$ [matsj] */
	sos_Enum_type e;	
        e = sos_Enum_type::create (cfe_cnt);
        e.set_name(yypvt[-4].str);
        e.set_object_size (cfe_enum_size (yypvt[-2].str_l.card()));
        e.set_literals(yypvt[-2].str_l);

        cfe_type_tab.insert (yypvt[-4].str, e);
        cfe_types.append (e);
	yyval.etd = e;
     } break;
case 23:
# line 270 "src/cfe/cfe.y"
{
	cfe_ct = cfe_make_class_type(yypvt[-0].str, cfe_type_tab, cfe_types);
        cfe_ct.set_is_abstract (cfe_class_is_abstract);
	cfe_type_tab.insert (yypvt[-0].str, cfe_ct);
     } break;
case 24:
# line 276 "src/cfe/cfe.y"
{  cfe_set_generic_stuff(cfe_ct, yypvt[-0].gp_l);
     } break;
case 25:
# line 279 "src/cfe/cfe.y"
{  cfe_ct.set_create_params (yypvt[-0].par_l);
     } break;
case 26:
# line 282 "src/cfe/cfe.y"
{  cfe_ct.set_super_classes (yypvt[-0].sc_l);
        mta_set_super_closure (cfe_ct);
     } break;
case 27:
# line 286 "src/cfe/cfe.y"
{  cfe_ct.set_friends (sos_Type_List::make (NO_OBJECT));
	cfe_ct.set_components (sos_Comp_descr_List::create(cfe_cnt));
	cfe_ct.set_has_init_comps (FALSE);
        cfe_init_methods (cfe_ct);
        cfe_component_offset = 0;
     } break;
case 28:
# line 293 "src/cfe/cfe.y"
{  yyval.ctd = cfe_ct;
	mta_complete_components (cfe_ct);
        mta_set_offsets_and_size (cfe_ct);
	mta_build_methodtable (cfe_ct);
        cfe_complete_methods (cfe_ct);
	cfe_types.append (yyval.ctd);
	cfe_create_universal_inst (cfe_ct);
	cfe_ct = sos_Class_type::make (NO_OBJECT);
     } break;
case 29:
# line 305 "src/cfe/cfe.y"
{ cfe_class_is_abstract = FALSE; } break;
case 30:
# line 307 "src/cfe/cfe.y"
{ cfe_class_is_abstract = TRUE; } break;
case 31:
# line 311 "src/cfe/cfe.y"
{  yyval.gp_l = sos_Gen_param_List::make (NO_OBJECT); } break;
case 32:
# line 313 "src/cfe/cfe.y"
{ if (cfe_is_full_type)
	   cfe_error (err_USE, err_CFE_FULL_GENERIC);
        yyval.gp_l = yypvt[-1].gp_l;
     } break;
case 33:
# line 321 "src/cfe/cfe.y"
{  yyval.gp_l = sos_Gen_param_List::create (cfe_cnt);
	yyval.gp_l.append (yypvt[-0].gp);
     } break;
case 34:
# line 325 "src/cfe/cfe.y"
{  if VALID(cfe_lookup_gen_params (yypvt[-0].gp.make_type().get_name(), yypvt[-2].gp_l))
           cfe_error (err_USE, err_CFE_AMBIGUOUS_GEN_PARAMS);
        yypvt[-2].gp_l.append (yypvt[-0].gp);
        yyval.gp_l = yypvt[-2].gp_l;
     } break;
case 35:
# line 334 "src/cfe/cfe.y"
{  yyval.gp = sos_Gen_param::create (cfe_cnt);
        yyval.gp.set_name (yypvt[-0].str);
        yyval.gp.set_super_type (sos_Type_descr::make(NO_OBJECT));
     } break;
case 36:
# line 339 "src/cfe/cfe.y"
{  yyval.gp = sos_Gen_param::create (cfe_cnt);
        yyval.gp.set_name (yypvt[-2].str);
        yyval.gp.set_super_type (yypvt[-0].td);
     } break;
case 37:
# line 346 "src/cfe/cfe.y"
{  yyval.par_l = sos_Param_List::make (NO_OBJECT); } break;
case 39:
# line 351 "src/cfe/cfe.y"
{  yyval.sc_l = sos_Super_class_List::create (cfe_cnt, TRUE);
        mta_enter_object_as_sc (cfe_ct, yyval.sc_l); // if cfe_ct not sos_Object, then
			                // enter sos_Object as only superclass
     } break;
case 40:
# line 356 "src/cfe/cfe.y"
{  cfe_check_super_classes (cfe_ct, yypvt[-0].sc_l);
	yyval.sc_l = yypvt[-0].sc_l;
     } break;
case 41:
# line 363 "src/cfe/cfe.y"
{  yyval.sc_l = sos_Super_class_List::create (cfe_cnt, TRUE);
	yyval.sc_l.append (yypvt[-0].sc);
     } break;
case 42:
# line 367 "src/cfe/cfe.y"
{  // check for multiple occurrence: generic instantiations are accounted
	// for correctly, since equal generic instantiations in the sc-list
	// become the same object by use of cfe_get_instantiation.
	if VALID(mta_super_class_in_list (yyval.sc_l, yypvt[-0].sc.get_super_class()))
	   cfe_error(err_USE, err_CFE_MULTIPLE_SUPERCLASS,
		     yypvt[-0].sc.make_type().get_name());
	yypvt[-2].sc_l.append (yypvt[-0].sc);
	yyval.sc_l = yypvt[-2].sc_l;
     } break;
case 43:
# line 380 "src/cfe/cfe.y"
{
	sos_Super_class sc = sos_Super_class::create (cfe_cnt);
	sc.set_super_class (yypvt[-0].td);
	sc.set_offset (0);
	sc.set_create_params(sos_Expr_List::make(NO_OBJECT));
	sc.set_is_direct (TRUE);
	yyval.sc = sc;
     } break;
case 44:
# line 389 "src/cfe/cfe.y"
{  sos_Super_class sc = sos_Super_class::create (cfe_cnt);
	sc.set_super_class (yypvt[-3].td);
	sc.set_create_params (yypvt[-1].exp_l);
	sc.set_is_direct (TRUE);
	yyval.sc = sc;
     } break;
case 45:
# line 398 "src/cfe/cfe.y"
{  cfe_method_kind     = sos_PRIVATE;
	cfe_set_method_kind = sos_PRIVATE;
     } break;
case 46:
# line 402 "src/cfe/cfe.y"
{  cfe_method_is_abstract = FALSE;
	cfe_method_is_definite = FALSE;
	cfe_method_is_local    = FALSE;
	cfe_method_is_operator = FALSE;
	cfe_method_is_static   = FALSE;
	cfe_method_is_value    = FALSE;
     } break;
case 51:
# line 417 "src/cfe/cfe.y"
{  cfe_method_kind = yypvt[-0].mk; } break;
case 54:
# line 429 "src/cfe/cfe.y"
{  cfe_fct_or_comp_type = yypvt[-0].td; } break;
case 55:
# line 434 "src/cfe/cfe.y"
{  cfe_method_is_abstract = TRUE; } break;
case 56:
# line 436 "src/cfe/cfe.y"
{  cfe_method_is_definite = TRUE; } break;
case 57:
# line 438 "src/cfe/cfe.y"
{  cfe_method_is_static = TRUE; } break;
case 60:
# line 445 "src/cfe/cfe.y"
{  cfe_method_is_local = TRUE; } break;
case 61:
# line 447 "src/cfe/cfe.y"
{  cfe_method_is_value = TRUE; } break;
case 62:
# line 452 "src/cfe/cfe.y"
{  yyval.mk = sos_PRIVATE; } break;
case 63:
# line 454 "src/cfe/cfe.y"
{  yyval.mk = sos_PROTECTED; } break;
case 64:
# line 456 "src/cfe/cfe.y"
{  yyval.mk = sos_PUBLIC; } break;
case 65:
# line 460 "src/cfe/cfe.y"
{  cfe_set_method_kind = cfe_method_kind; } break;
case 66:
# line 462 "src/cfe/cfe.y"
{  cfe_set_method_kind = yypvt[-1].mk; } break;
case 67:
# line 467 "src/cfe/cfe.y"
{
	if (cfe_method_is_local)
	   cfe_error(err_USE, err_CFE_NO_LOCAL_FUNCS);
	if (cfe_method_is_value)
	   cfe_error(err_USE, err_CFE_NO_VALUE_FUNCS);
	   
	sos_Method m = sos_Method::create (cfe_cnt);
	m.set_name (yypvt[-2].str);
	m.set_is_abstract (cfe_method_is_abstract);
	if (cfe_method_is_abstract)
	{
	   cfe_ct.set_is_abstract (TRUE);
	   // Now check: private methods must not be abstract
	   if (cfe_method_kind == sos_PRIVATE)
	      cfe_error(err_USE, err_CFE_PRIVATE_METHOD_ABSTRACT);
	}
	m.set_is_definite (cfe_method_is_definite);
	m.set_is_static (cfe_method_is_static);
	m.set_is_operator (cfe_method_is_operator);
	m.set_is_generated (FALSE);
	m.set_params (yypvt[-1].par_l);
	m.set_result_type (cfe_fct_or_comp_type);
	m.set_kind (cfe_method_kind);
	m.set_defined_in (cfe_ct);
	m.set_generated_from (sos_Method::make(NO_OBJECT));
	m.set_impls (sos_Method_impl_List::make (NO_OBJECT));
	cfe_ct.get_local_methods().append(m);
	yyval.md = m;
     } break;
case 68:
# line 500 "src/cfe/cfe.y"
{  yyval.str = yypvt[-0].str;
     } break;
case 69:
# line 503 "src/cfe/cfe.y"
{  yyval.str = yypvt[-0].str;
        cfe_method_is_operator = TRUE;
     } break;
case 70:
# line 510 "src/cfe/cfe.y"
{  yyval.str = yypvt[-0].str; } break;
case 71:
# line 514 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "*"); } break;
case 72:
# line 515 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "/"); } break;
case 73:
# line 516 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "%"); } break;
case 74:
# line 517 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "+"); } break;
case 75:
# line 518 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "-"); } break;
case 76:
# line 519 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, ">>"); } break;
case 77:
# line 520 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "<<"); } break;
case 78:
# line 521 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, ">"); } break;
case 79:
# line 522 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "<"); } break;
case 80:
# line 523 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "=="); } break;
case 81:
# line 524 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "!="); } break;
case 82:
# line 525 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "<="); } break;
case 83:
# line 526 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, ">="); } break;
case 84:
# line 527 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "&"); } break;
case 85:
# line 528 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "^"); } break;
case 86:
# line 529 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "|"); } break;
case 87:
# line 530 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "&&"); } break;
case 88:
# line 531 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "||"); } break;
case 89:
# line 532 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "="); } break;
case 90:
# line 533 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "+="); } break;
case 91:
# line 534 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "-="); } break;
case 92:
# line 535 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "*="); } break;
case 93:
# line 536 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "/="); } break;
case 94:
# line 537 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "%="); } break;
case 95:
# line 538 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "^="); } break;
case 96:
# line 539 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "&="); } break;
case 97:
# line 540 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "|="); } break;
case 98:
# line 541 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, ">>="); } break;
case 99:
# line 542 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "<<="); } break;
case 100:
# line 543 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "()"); } break;
case 101:
# line 544 "src/cfe/cfe.y"
{ yyval.str = sos_String::create (cfe_cnt, "[]"); } break;
case 102:
# line 549 "src/cfe/cfe.y"
{  yyval.par_l = sos_Param_List::make (NO_OBJECT); } break;
case 103:
# line 551 "src/cfe/cfe.y"
{  yyval.par_l = yypvt[-1].par_l; } break;
case 104:
# line 556 "src/cfe/cfe.y"
{  yyval.par_l = sos_Param_List::create (cfe_cnt, FALSE);
	yyval.par_l.append (yypvt[-0].par);
     } break;
case 105:
# line 560 "src/cfe/cfe.y"
{  yypvt[-2].par_l.append (yypvt[-0].par);
	yyval.par_l = yypvt[-2].par_l;
     } break;
case 106:
# line 567 "src/cfe/cfe.y"
{  if (yypvt[-2].b && VALID(yypvt[-0].exp))
	   cfe_error(err_USE, err_CFE_DEFAULT_FOR_REFERENCE);
	yyval.par = sos_Param::create (cfe_cnt);
	yyval.par.set_name (yypvt[-1].str);
	yyval.par.set_type (yypvt[-3].td);
	yyval.par.set_default_expr (yypvt[-0].exp);
	yyval.par.set_is_ref (yypvt[-2].b);
     } break;
case 107:
# line 576 "src/cfe/cfe.y"
{  if (yypvt[-1].b && VALID(yypvt[-0].exp))
	   cfe_error(err_USE, err_CFE_DEFAULT_FOR_REFERENCE);
        yyval.par = sos_Param::create (cfe_cnt);
	yyval.par.set_name (sos_String::make (NO_OBJECT));
	yyval.par.set_type (yypvt[-2].td);
	yyval.par.set_default_expr (yypvt[-0].exp);
	yyval.par.set_is_ref (yypvt[-1].b);
     } break;
case 108:
# line 587 "src/cfe/cfe.y"
{  yyval.b = FALSE; } break;
case 109:
# line 589 "src/cfe/cfe.y"
{  yyval.b = TRUE; } break;
case 110:
# line 594 "src/cfe/cfe.y"
{  yyval.exp = sos_Expr::make (NO_OBJECT); } break;
case 111:
# line 596 "src/cfe/cfe.y"
{  yyval.exp = yypvt[-0].exp; } break;
case 115:
# line 610 "src/cfe/cfe.y"
{
        if (cfe_method_is_static)
	   cfe_error(err_USE, err_CFE_NO_STATIC_COMPS);
        if (cfe_method_is_value)
	   cfe_error(err_USE, err_CFE_NO_VALUE_COMPS);
	if (cfe_method_is_abstract)
	   cfe_error(err_USE, err_CFE_ABSTRACT_COMP);
        cfe_append_comp_methods (cfe_ct, cfe_fct_or_comp_type, yypvt[-1].str, yypvt[-0].exp,
				 cfe_method_kind, cfe_set_method_kind,
				 cfe_method_is_value, cfe_method_is_local,
				 cfe_method_is_definite, cfe_component_offset);
        if VALID(yypvt[-0].exp)
	   cfe_ct.set_has_init_comps (TRUE);
     } break;
case 116:
# line 628 "src/cfe/cfe.y"
{  sos_Type_List fl = cfe_ct.get_friends();
	if INVALID(fl)
	   cfe_ct.set_friends (fl = sos_Type_List::create (cfe_cnt));
	fl.append (yypvt[-1].td.make_type());
     } break;
case 117:
# line 637 "src/cfe/cfe.y"
{  cfe_check_type (yypvt[-0].str); } break;
case 118:
# line 639 "src/cfe/cfe.y"
{  sos_Union_type u = sos_Union_type::create (cfe_cnt);
	u.set_name (yypvt[-5].str);
	u.set_united (yypvt[-2].tp_l);
	u.set_object_size (0);

	cfe_type_tab.insert (yypvt[-5].str, u);
	cfe_types.append (u);
	yyval.utd = u;
     } break;
case 119:
# line 652 "src/cfe/cfe.y"
{  sos_Typedef_type t = sos_Typedef_type::create (cfe_cnt);
        t.set_name (yypvt[-0].str);
        t.set_named_type (yypvt[-1].td.make_type());
	cfe_check_type (yypvt[-0].str);

        cfe_type_tab.insert (yypvt[-0].str, t);
        cfe_types.append (t);
	yyval.ttd = t;
     } break;
case 120:
# line 665 "src/cfe/cfe.y"
{  cfe_check_type (yypvt[-1].str);
        sos_Extern_type e = sos_Extern_type::create (cfe_cnt);
        e.set_name (yypvt[-1].str);
        e.set_object_size (yypvt[-0].i);
        cfe_schema.set_has_external_types (TRUE);

        cfe_type_tab.insert (yypvt[-1].str, e);
        cfe_types.append (e);
	yyval.xtd = e;
     } break;
case 121:
# line 678 "src/cfe/cfe.y"
{  yyval.i = 4; } break;
case 122:
# line 680 "src/cfe/cfe.y"
{  yyval.i = yypvt[-1].i;
	if (yypvt[-1].i > SOS_ID_SIZE)
	   cfe_error (err_USE, err_CFE_INVALID_EXT_SIZE);
     } break;
case 123:
# line 688 "src/cfe/cfe.y"
{  yyval.td = cfe_lookup_type_name (cfe_ct, yypvt[-0].str, sos_IMP_SUPERCLASS); 
	cfe_check_no_generic (yyval.td);
     } break;
case 124:
# line 692 "src/cfe/cfe.y"
{  yyval.td = yypvt[-0].td; } break;
case 125:
# line 697 "src/cfe/cfe.y"
{  yyval.td = cfe_lookup_type_name (cfe_ct, yypvt[-0].str, sos_IMP_TYPE); 
	cfe_check_no_generic (yyval.td);
     } break;
case 126:
# line 701 "src/cfe/cfe.y"
{  yyval.td = yypvt[-0].td; } break;
case 127:
# line 706 "src/cfe/cfe.y"
{  yyval.td = cfe_lookup_type_name (cfe_ct, yypvt[-0].str, sos_IMP_TYPE); } break;
case 128:
# line 708 "src/cfe/cfe.y"
{  yyval.td = yypvt[-0].td; } break;
case 129:
# line 712 "src/cfe/cfe.y"
{  yyval.exp_l = sos_Expr_List::create (cfe_cnt); } break;
case 131:
# line 718 "src/cfe/cfe.y"
{  yyval.exp_l = sos_Expr_List::create (cfe_cnt);
        yyval.exp_l.append (yypvt[-0].exp);
     } break;
case 132:
# line 722 "src/cfe/cfe.y"
{  yypvt[-2].exp_l.append (yypvt[-0].exp);
        yyval.exp_l = yypvt[-2].exp_l;
     } break;
case 133:
# line 728 "src/cfe/cfe.y"
{ yyval.exp = yypvt[-0].id; } break;
case 134:
# line 729 "src/cfe/cfe.y"
{ yyval.exp = yypvt[-0].ie; } break;
case 135:
# line 734 "src/cfe/cfe.y"
{  yyval.id = sos_Identifier::create (cfe_cnt);
        yyval.id.set_id (yypvt[-0].str);
     } break;
case 136:
# line 741 "src/cfe/cfe.y"
{  yyval.ie = sos_Int_expr::create (cfe_cnt);
	yyval.ie.set_value (yypvt[-0].i);
     } break;
case 137:
# line 748 "src/cfe/cfe.y"
{  sos_Type_descr gi = cfe_lookup_generic_instantiation (yypvt[-3].str, yypvt[-1].td_l,
			       sos_IMP_SUPERCLASS, cfe_types);
	cfe_gen_insts.append (gi);
	yyval.td = gi;
     } break;
case 138:
# line 757 "src/cfe/cfe.y"
{  sos_Type_descr gi = cfe_lookup_generic_instantiation (yypvt[-3].str, yypvt[-1].td_l,
			       sos_IMP_GENERIC, cfe_types);
	cfe_gen_insts.append (gi);
	yyval.td = gi;
     } break;
case 139:
# line 766 "src/cfe/cfe.y"
{  yyval.tp_l = sos_Type_List::create (cfe_cnt);
	yyval.tp_l.append (yypvt[-0].td.make_type());
     } break;
case 140:
# line 770 "src/cfe/cfe.y"
{  yypvt[-2].tp_l.append (yypvt[-0].td.make_type());
	yyval.tp_l = yypvt[-2].tp_l;
     } break;
case 141:
# line 777 "src/cfe/cfe.y"
{  yyval.td_l = sos_Type_descr_List::create (cfe_cnt);
	yyval.td_l.append (yypvt[-0].td);
     } break;
case 142:
# line 781 "src/cfe/cfe.y"
{  yypvt[-2].td_l.append (yypvt[-0].td);
	yyval.td_l = yypvt[-2].td_l;
     } break;
case 143:
# line 788 "src/cfe/cfe.y"
{  yyval.str = sos_String::create (TEMP_CONTAINER, yypvt[-0].s);
	delete yypvt[-0].s;
     } break;
case 144:
# line 795 "src/cfe/cfe.y"
{  yyval.str_l = sos_String_List::create (cfe_cnt, FALSE, TRUE);
	yyval.str_l.append (yypvt[-0].str);
     } break;
case 145:
# line 799 "src/cfe/cfe.y"
{  yypvt[-2].str_l.append (yypvt[-0].str);
	yyval.str_l = yypvt[-2].str_l;
     } break;
case 146:
# line 806 "src/cfe/cfe.y"
{  yyval.str = sos_String::create (cfe_cnt, yypvt[-0].s);
        delete yypvt[-0].s;
     } break;
case 147:
# line 812 "src/cfe/cfe.y"
{ yyval.s = yypvt[-0].s; } break;
case 148:
# line 813 "src/cfe/cfe.y"
{ yyval.s = obst_strdup ("set"); } break;
	}
	goto yystack;		/* reset registers in driver code */
}
