#ifndef _MSH_ERR_H
#define _MSH_ERR_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the licence
 * you should have received along with this program.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
// ********************************************************************
// msh_err.h
// ********************************************************************

#include "obst_err.h"

extern const err_msg err_MSH_LEXICAL_ERROR;

extern const err_msg err_MSH_INVALID_METHOD_NAME;
extern const err_msg err_MSH_OVERLOADED_METHOD;
extern const err_msg err_MSH_TYPE_NOT_FOUND;
extern const err_msg err_MSH_OVERLOADED_NOT_FOUND;
extern const err_msg err_MSH_FILE_NOT_FOUND;

#endif /* _MSH_ERR_H */
