
#define yylineno	msh_yylineno
#define yyin		msh_yyin
#define yyreds		msh_yyreds
#define yyout		msh_yyout
#define yyparse		msh_yyparse
#define yylex		msh_yylex
#define yyerror		msh_yyerror
#define yylval		msh_yylval
#define yyunput         msh_yyunput
#define yyinput         msh_yyinput
#define yyoutput        msh_yyoutput
#define yyval		msh_yyval
#define yys		msh_yys
#define yyv		msh_yyv
#define yypv		msh_yypv
# define name_tok 257
# define number_tok 258
# define abstract_tok 259
# define class_tok 260
# define commit_tok 261
# define comp_tok 262
# define create_tok 263
# define create_par_tok 264
# define definite_tok 265
# define endversion_tok 266
# define enum_tok 267
# define exit_tok 268
# define extern_tok 269
# define friend_tok 270
# define generate_tok 271
# define help_tok 272
# define import_tok 273
# define init_tok 274
# define insert_tok 275
# define instantiation_tok 276
# define literal_tok 277
# define local_tok 278
# define method_tok 279
# define nname_tok 280
# define operator_tok 281
# define param_tok 282
# define period_tok 283
# define print_tok 284
# define private_tok 285
# define protected_tok 286
# define prot_gen_tok 287
# define public_tok 288
# define quit_tok 289
# define recursive_tok 290
# define ref_tok 291
# define reset_tok 292
# define result_tok 293
# define remove_tok 294
# define schema_tok 295
# define scope_tok 296
# define set_tok 297
# define size_tok 298
# define static_tok 299
# define subclass_tok 300
# define super_tok 301
# define type_tok 302
# define typedef_tok 303
# define union_tok 304
# define update_tok 305
# define wait_tok 306
# define with_tok 307
# define with_extern_tok 308
# define l_abr_tok 309
# define r_abr_tok 310
# define l_br_tok 311
# define r_br_tok 312
# define l_brc_tok 313
# define r_brc_tok 314
# define l_par_tok 315
# define r_par_tok 316
# define ampersand_tok 317
# define ampersand_assign_tok 318
# define and_tok 319
# define assign_tok 320
# define bar_tok 321
# define bar_assign_tok 322
# define circumflex_tok 323
# define circumflex_assign_tok 324
# define colon_tok 325
# define comma_tok 326
# define equal_tok 327
# define exclam_tok 328
# define greater_equal_tok 329
# define less_equal_tok 330
# define minus_tok 331
# define minus_assign_tok 332
# define not_equal_tok 333
# define or_tok 334
# define percent_tok 335
# define percent_assign_tok 336
# define plus_tok 337
# define plus_assign_tok 338
# define rshift_assign_tok 339
# define lshift_assign_tok 340
# define slash_tok 341
# define slash_assign_tok 342
# define star_tok 343
# define star_assign_tok 344
# define semicolon_tok 345

# line 133 "src/mtools/msh.y"

#define OBST_IMP_STRINGOP
#define OBST_IMP_MALLOC
#include "obst_stdinc.h"
#include "_obst_config.h"
#include "obst_progstd.h"

#include "msh.h"		// includes msh_err.h
#include "mta.h"

typedef union {
	  sos_Bool				b;
	  sos_Bool *				b_poi;
	  sos_Int				i;
	  sos_Cstring				s;
	  sos_Comp_descr			cd;
	  sos_Schema_module			smdl;
          sos_Import_List			imp;
          sos_String				str;
          sos_String_List			str_l;
          sos_Enum_type				etd;
          sos_Class_type			ctd;
          sos_Gen_param				gp;
          sos_Gen_param_List			gp_l;
          sos_Param				par;
          sos_Param_List			par_l;
	  sos_Method_kind			mk;
          sos_Method_List			md_l;
          sos_Method				md;
          sos_Union_type			utd;
	  sos_Type				t;
          sos_Typedef_type			ttd;
          sos_Extern_type			xtd;
	  sos_Type_descr			td;
	  sos_Type_descr_List			td_l;
	  sos_Type_List				tp_l;
	  sos_Super_class_List			sc_l;
	  sos_Super_class			sc;
          sos_Expr				exp;
          sos_Int_expr				ie;
          sos_Identifier			id;
          sos_Expr_List				exp_l;
        } _YYSTYPE;

#define YYSTYPE _YYSTYPE

LOCAL sos_Schema_module	msh_schema;
LOCAL sos_Class_type	msh_class;
LOCAL sos_Comp_descr	msh_cd;
LOCAL sos_Method	msh_method;
LOCAL sos_Param		msh_param;
LOCAL sos_Expr		msh_init_expr;
LOCAL sos_Int		msh_integer;
LOCAL sos_String	msh_name;
LOCAL sos_Container	msh_cnt;
LOCAL sos_Type_descr	msh_result_type;
LOCAL sos_Method_kind	msh_scope;
LOCAL sos_Method_kind	msh_set_scope;
LOCAL sos_Method_kind	msh_get_scope;
LOCAL sos_Bool		msh_is_static;
LOCAL sos_Bool		msh_is_local;
LOCAL sos_Bool		msh_is_abstract;
LOCAL sos_Bool		msh_is_definite;
LOCAL sos_Bool		msh_is_reference;

#include "msh_lex.h"

LOCAL inline void yyerror (err_msg s)
{  msh_error (err_USE, s);
}
LOCAL inline void yyecho ()
{  if (msh_echo)
      ECHO;
}
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 879 "src/mtools/msh.y"

static int yyexca[] ={
-1, 0,
	0, 1,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 16,
	0, 1,
	-2, 0,
-1, 92,
	284, 61,
	-2, 63,
-1, 93,
	284, 67,
	-2, 69,
-1, 94,
	280, 75,
	284, 73,
	-2, 71,
-1, 95,
	284, 160,
	-2, 162,
-1, 96,
	284, 165,
	-2, 167,
	};
# define YYNPROD 187
# define YYLAST 531
static int yyact[]={

    20,   286,   280,    82,   124,    16,   277,   154,    43,   216,
   231,   209,   278,   347,   298,   262,   232,   257,    66,   297,
   361,   210,    43,   311,   355,   217,   353,   340,   337,   247,
   336,   323,   307,    62,   306,    38,   291,   290,   282,   289,
    60,   256,    63,   215,    47,   172,    52,    42,    70,    79,
   230,   254,   182,    45,   164,   160,    41,    49,   157,   281,
    51,    74,    75,    76,    77,    78,    18,    21,   125,   329,
   322,   288,   166,   300,   236,    85,    64,    61,   223,   219,
    87,    46,    97,   166,    21,   288,   166,   162,   116,   212,
   125,    70,   102,   211,   162,    39,   174,    11,    21,    88,
   153,   246,     3,    80,   113,   359,   138,     9,   141,     5,
    89,    84,   126,    12,   131,    29,    83,    31,   352,   351,
   140,   334,    26,   139,    28,   349,   317,   333,   296,   295,
     6,   294,   293,     4,    30,   272,    15,   271,   332,   270,
   231,   313,   158,   260,   130,   137,   232,    10,   214,   331,
    24,   169,   170,   171,   168,   244,   167,    25,    27,   247,
   184,   242,    81,   273,   175,   261,    34,    43,   203,   231,
   188,   190,   196,   195,   243,   232,   185,   245,   121,   123,
   230,   198,   199,   200,   201,    90,   285,    33,   165,   178,
   191,   177,   213,   150,   274,   291,   290,    35,   289,   204,
   231,   103,   345,   106,   344,   184,   232,   186,   179,   230,
   176,   189,   151,   343,   291,   290,    91,   289,   342,   234,
   235,   228,   107,   229,   241,   275,   267,   239,   266,   265,
   264,   248,   263,   252,   227,   251,   250,   226,   249,   238,
   230,   221,   208,   192,   259,   180,   163,   156,   155,   152,
   147,   144,   119,   269,    96,    95,    94,    93,    92,    73,
    72,    71,    68,    67,    36,    17,   202,   292,    43,   314,
   233,   193,   173,   302,    43,    37,   301,   183,   120,   161,
    19,    69,   122,   118,     1,   117,   312,   115,   114,   315,
   324,   268,   330,   305,   319,   303,   315,   253,   321,   320,
   326,    22,   328,   224,   187,   222,   206,   283,   360,   346,
   225,   240,   205,   181,   159,   335,   308,   279,   237,   258,
   136,   135,   134,   133,   338,   132,   112,   111,   129,   110,
   109,   108,   105,   104,    58,    57,    56,   341,    55,    54,
    53,    86,    50,    48,   339,    44,    40,   350,   348,   354,
    32,    14,   357,    13,   356,   358,   194,    23,     8,     7,
     2,    59,   197,   284,    65,   299,     0,     0,    98,    99,
   100,     0,   101,     0,     0,     0,     0,     0,     0,   309,
     0,     0,     0,     0,     0,     0,     0,   127,     0,     0,
   142,   218,   128,   145,     0,   143,   148,     0,   146,   325,
   327,   149,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   255,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   318,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   316,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   304,     0,   310,   207,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   220,     0,     0,     0,     0,   287,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   276 };
static int yypact[]={

  -159, -1000,  -340, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,   -18, -1000, -1000,  -217,  -159,  -145,   -97,   -19,
 -1000,    18, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,  -248,  -220, -1000,  -260, -1000,    17,
  -227, -1000,  -308, -1000, -1000,   -20,   -21,  -248, -1000, -1000,
 -1000,   -22,   -23, -1000, -1000, -1000, -1000, -1000, -1000,   -24,
  -248,  -248,  -248,  -248,  -248,  -267,  -187,  -135,  -181, -1000,
 -1000,  -181,  -195,   -78,   -25,   -26,   -27,   -28,   -29, -1000,
 -1000,  -248, -1000, -1000, -1000, -1000, -1000,  -248,  -248,  -248,
  -248,  -248,   -76,   -72, -1000,  -194,  -214, -1000, -1000, -1000,
 -1000, -1000, -1000,   -31,  -106,  -101,  -247,  -247,  -106,  -101,
  -156,  -106,  -101,   -32,  -106,  -101,   -33,  -106,  -101,   -82,
 -1000, -1000, -1000,   -34, -1000,    17, -1000, -1000, -1000, -1000,
   -35,   -36, -1000, -1000, -1000, -1000, -1000,  -225, -1000,  -228,
   -37,  -229, -1000, -1000,  -141, -1000, -1000,  -143, -1000, -1000,
  -248,  -248,  -144,  -271,  -213,  -120,   -84,   -86,   -38,  -231,
   -87, -1000,    17,   -52,  -104,   -40,    13,  -243,  -247, -1000,
 -1000,  -248, -1000, -1000, -1000, -1000,  -247,  -247,  -247,  -247,
     2, -1000,   -95, -1000, -1000, -1000,  -221,   -41,  -305,  -222,
  -226,  -248,  -149,  -273, -1000, -1000, -1000,  -301, -1000, -1000,
 -1000, -1000,  -243,  -236,  -248,   -42,  -237, -1000,   -59, -1000,
    12,    17,    17, -1000,  -241, -1000, -1000,    17,   -44,    17,
 -1000,  -119, -1000,    17, -1000,   -45,   -47,   -48,   -50,  -232,
 -1000, -1000, -1000,  -275,  -309, -1000,    17, -1000,  -154,  -311,
 -1000,   -51,   -53,   -54,   -55,   -57, -1000, -1000, -1000,  -181,
  -158,  -160,  -162, -1000,  -100,   -58, -1000,  -213,  -314, -1000,
  -256,  -278,  -249,  -181,  -165,  -166,  -168,  -169,  -312, -1000,
  -242,  -247,  -248, -1000,  -243, -1000,  -282,  -284,  -235,  -314,
 -1000,    11, -1000,  -311, -1000, -1000,  -171, -1000,    11, -1000,
 -1000, -1000, -1000,  -248,  -247,  -256,  -245,  -285,   -90, -1000,
   -71, -1000, -1000,  -246, -1000,  -153, -1000, -1000,  -314, -1000,
 -1000, -1000,  -286,  -288, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,   -71, -1000,  -312, -1000, -1000, -1000,  -289,    17,
 -1000,   -65,   -70,   -79,   -81, -1000, -1000, -1000,  -313, -1000,
 -1000,  -314,  -172,  -181,  -178,  -179,  -290,   -71,  -292,  -247,
 -1000,  -248,  -256, -1000,  -192, -1000, -1000, -1000, -1000, -1000,
  -296, -1000 };
static int yypgo[]={

     0,   100,     4,   365,     1,   279,   188,     0,   281,     7,
   141,   186,     2,   364,   362,   272,   361,     3,   280,   277,
   224,   101,   284,   360,   359,   358,   357,   353,   351,   350,
   346,   345,   343,   342,   341,   340,   339,   338,   336,   335,
   334,   282,   278,   333,   332,   331,   330,   329,   328,   327,
   326,   325,   323,   322,   321,   320,   319,     6,   317,   316,
   314,   313,   165,   312,   311,   309,   308,   307,   306,   305,
   304,   303,   297,   295,   293,   292,   291,    19,   290,   288,
   287,   285,   283 };
static int yyr1[]={

     0,    22,    22,    23,    23,    23,    23,    23,    23,    23,
    23,    23,    24,    24,    26,    26,    26,    26,    26,    26,
    26,    26,    25,    25,    28,    29,    29,    29,    13,    13,
    30,    27,    31,    31,    31,    31,    31,    31,    31,    32,
    34,    34,    34,    34,    33,    33,    33,    33,    33,    33,
    35,    35,    41,    42,    16,    16,    16,    16,    16,    36,
    36,    43,    36,    44,    36,    37,    37,    45,    37,    46,
    37,    47,    38,    49,    38,    50,    38,    48,    48,    48,
    48,    48,    48,    48,    48,    56,    55,    55,    58,    55,
    57,    57,    59,    59,    59,    51,    51,    51,    60,    52,
    61,    61,    63,    61,    19,    64,    64,    64,    64,    65,
    64,    66,    64,    20,    20,    21,    21,    21,     4,     4,
     4,     3,    62,    62,    67,    67,    67,    67,    67,    68,
    53,    53,    70,    53,    71,    71,    71,    71,    71,    73,
    72,    72,    74,    72,    75,    75,    75,    75,     5,     5,
    76,    69,    77,    77,    78,    78,    78,    54,    15,    39,
    79,    39,    80,    39,    40,    81,    40,    82,    40,     6,
    18,     9,     7,     8,     8,    10,    10,    17,    17,    11,
    11,    12,     2,     1,     1,    14,    14 };
static int yyr2[]={

     0,     0,     6,     3,     3,     3,     3,     2,     2,     3,
     3,     2,     3,     6,     3,     3,     3,     3,     3,     3,
     3,     3,     2,     2,     6,     3,     5,    11,     1,     5,
     1,    10,     9,     7,     5,     2,     3,     2,     7,     6,
     5,     5,     5,     3,     2,     2,     2,     2,     2,     2,
     9,     9,     9,     3,     3,     3,     3,     3,     3,    15,
    15,     1,    10,     1,    10,    11,    11,     1,    10,     1,
    10,     1,    10,     1,    10,     1,    10,     7,     9,     9,
     2,     2,     2,     2,     2,     1,    17,     9,     1,    19,
     0,     6,     3,     3,     3,     9,     9,    17,     1,     6,
    13,     7,     1,     9,     3,     7,     9,     9,     9,     1,
    14,     1,    20,     2,     3,     3,     3,     3,     3,     3,
     3,     7,     0,     6,     3,     3,     3,     5,     2,     1,
    11,     9,     1,    10,     7,     9,     9,     9,     4,     1,
    15,     7,     1,     9,     9,     7,     9,     9,     7,    11,
     1,    10,     0,     6,     3,     3,     2,    16,     7,    15,
     1,    10,     1,    10,    15,     1,    10,     1,    10,     7,
     3,     3,     7,     1,     2,     3,     3,     3,     3,     5,
     3,     7,     7,     3,     5,     1,     7 };
static int yychk[]={

 -1000,   -22,   -23,   261,   292,   268,   289,   -24,   -25,   266,
   306,   256,   272,   -27,   -28,   295,   345,   283,   283,   -18,
    -7,   315,   -22,   -26,   295,   302,   267,   303,   269,   260,
   279,   262,   -29,   284,   263,   294,   283,   257,    -7,   315,
   -30,   316,    -9,   257,   -31,   280,   308,   271,   -32,   284,
   -33,   287,   273,   -35,   -36,   -37,   -38,   -39,   -40,   -16,
   267,   304,   260,   269,   303,   -13,   326,   283,   283,    -8,
    -7,   283,   283,   283,    -7,    -7,    -7,    -7,    -7,   316,
   290,   297,   -17,   297,   292,   -17,   -34,   275,   294,   305,
   263,   294,   283,   283,   283,   283,   283,    -7,   -18,   -18,
   -18,    -8,    -7,   277,   -43,   -44,   275,   294,   -45,   -46,
   -47,   -49,   -50,   298,   -79,   -80,   302,   -81,   -82,   283,
   -42,   284,   -41,   280,    -2,   315,    -2,   -42,   -41,   -48,
   300,   270,   -51,   -52,   -53,   -54,   -55,   301,   262,   279,
   276,   264,   -42,   -41,   283,   -42,   -41,   283,   -42,   -41,
   275,   294,   283,    -1,    -9,   283,   283,   283,    -2,   -60,
   283,    -5,   315,   283,   283,    -6,   315,   297,   297,    -7,
    -7,   297,   316,   -15,   309,   284,   294,   275,   275,   294,
   283,   -61,   283,   -19,    -7,   263,   294,   -70,    -9,   263,
   275,   294,   283,   258,    -6,    -2,    -7,   -14,    -2,    -2,
    -2,    -2,   264,   263,   294,   -63,   -68,    -5,   283,   316,
   326,   315,   315,    -7,   297,   316,   310,   326,    -6,   315,
   -19,   283,   -69,   315,   -71,   -21,   296,   293,   280,   282,
   299,   259,   265,   258,    -9,    -9,   315,    -1,   283,    -9,
   -64,   -20,   280,   293,   274,   296,   -21,   278,    -9,   283,
   283,   283,   283,   -72,   283,    -6,   316,   326,   -56,    -9,
   297,   -62,   326,   283,   283,   283,   283,   283,   -76,   -17,
   297,   297,   297,   263,   294,   283,   -15,   -57,   326,   -58,
   -12,   315,   316,   -67,    -1,   -11,    -4,   -20,   320,   288,
   286,   285,   -17,   297,   297,   297,   297,   -77,   326,    -3,
   315,    -2,    -7,   -73,    -6,   -74,   316,   316,   -59,    -1,
   -11,   258,   -57,   -10,   258,    -9,   -62,   297,   -10,    -7,
    -2,   -12,   315,   316,   -78,    -1,    -4,   -21,    -4,   315,
   -75,   302,   291,   280,   274,   -57,   316,   316,    -4,   -77,
   316,    -9,   283,   283,   283,   283,   -65,   326,   -57,   297,
   -17,   297,   297,   316,    -4,   316,    -2,    -7,   -12,   297,
   -66,   316 };
static int yydef[]={

    -2,    -2,     0,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    22,    23,     0,    -2,     0,     0,     0,
   170,     0,     2,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    24,    25,     0,     0,    30,     0,    26,     0,
     0,   172,    28,   171,    31,     0,     0,   173,    35,    36,
    37,     0,     0,    44,    45,    46,    47,    48,    49,     0,
    54,    55,    56,    57,    58,     0,     0,     0,     0,    34,
   174,     0,     0,     0,     0,     0,     0,     0,     0,    27,
    29,     0,    33,   177,   178,    38,    39,     0,     0,    43,
   173,     0,    -2,    -2,    -2,    -2,    -2,    32,    40,    41,
    42,    50,    51,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    62,    53,    64,     0,    65,     0,    66,    68,    70,    72,
     0,     0,    80,    81,    82,    83,    84,     0,    98,     0,
     0,     0,    74,    76,     0,   161,   163,     0,   166,   168,
     0,     0,     0,     0,   183,     0,     0,     0,     0,     0,
     0,   132,     0,     0,     0,     0,     0,     0,     0,    59,
    60,     0,   182,   184,   185,    77,     0,     0,     0,     0,
     0,    99,     0,   102,   104,   129,     0,     0,     0,     0,
     0,     0,     0,     0,   159,   164,    52,     0,    78,    79,
    95,    96,     0,     0,     0,     0,     0,   131,     0,   148,
     0,     0,     0,    87,     0,   169,   158,     0,     0,     0,
   101,     0,   130,     0,   133,     0,     0,     0,     0,     0,
   115,   116,   117,     0,     0,    85,     0,   186,     0,   122,
   103,     0,     0,     0,     0,     0,   113,   114,   150,     0,
     0,     0,     0,   138,     0,     0,   149,     0,    90,    88,
     0,     0,     0,     0,     0,     0,     0,     0,   152,   134,
     0,     0,     0,   139,     0,   142,     0,     0,     0,    90,
    97,     0,   100,   122,   124,   125,   126,   128,   180,   118,
   119,   120,   105,     0,     0,     0,     0,     0,     0,   135,
     0,   136,   137,     0,   141,     0,   157,    86,    90,    92,
    93,    94,     0,     0,   175,   176,   123,   127,   179,   106,
   107,   108,     0,   151,   152,   154,   155,   156,     0,     0,
   143,     0,     0,     0,     0,    91,    89,   181,   109,   153,
   121,    90,     0,     0,     0,     0,     0,     0,     0,     0,
   145,     0,     0,   110,     0,   140,   144,   146,   147,   111,
     0,   112 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

static yytoktype yytoks[] =
{
	"name_tok",	257,
	"number_tok",	258,
	"abstract_tok",	259,
	"class_tok",	260,
	"commit_tok",	261,
	"comp_tok",	262,
	"create_tok",	263,
	"create_par_tok",	264,
	"definite_tok",	265,
	"endversion_tok",	266,
	"enum_tok",	267,
	"exit_tok",	268,
	"extern_tok",	269,
	"friend_tok",	270,
	"generate_tok",	271,
	"help_tok",	272,
	"import_tok",	273,
	"init_tok",	274,
	"insert_tok",	275,
	"instantiation_tok",	276,
	"literal_tok",	277,
	"local_tok",	278,
	"method_tok",	279,
	"nname_tok",	280,
	"operator_tok",	281,
	"param_tok",	282,
	"period_tok",	283,
	"print_tok",	284,
	"private_tok",	285,
	"protected_tok",	286,
	"prot_gen_tok",	287,
	"public_tok",	288,
	"quit_tok",	289,
	"recursive_tok",	290,
	"ref_tok",	291,
	"reset_tok",	292,
	"result_tok",	293,
	"remove_tok",	294,
	"schema_tok",	295,
	"scope_tok",	296,
	"set_tok",	297,
	"size_tok",	298,
	"static_tok",	299,
	"subclass_tok",	300,
	"super_tok",	301,
	"type_tok",	302,
	"typedef_tok",	303,
	"union_tok",	304,
	"update_tok",	305,
	"wait_tok",	306,
	"with_tok",	307,
	"with_extern_tok",	308,
	"l_abr_tok",	309,
	"r_abr_tok",	310,
	"l_br_tok",	311,
	"r_br_tok",	312,
	"l_brc_tok",	313,
	"r_brc_tok",	314,
	"l_par_tok",	315,
	"r_par_tok",	316,
	"ampersand_tok",	317,
	"ampersand_assign_tok",	318,
	"and_tok",	319,
	"assign_tok",	320,
	"bar_tok",	321,
	"bar_assign_tok",	322,
	"circumflex_tok",	323,
	"circumflex_assign_tok",	324,
	"colon_tok",	325,
	"comma_tok",	326,
	"equal_tok",	327,
	"exclam_tok",	328,
	"greater_equal_tok",	329,
	"less_equal_tok",	330,
	"minus_tok",	331,
	"minus_assign_tok",	332,
	"not_equal_tok",	333,
	"or_tok",	334,
	"percent_tok",	335,
	"percent_assign_tok",	336,
	"plus_tok",	337,
	"plus_assign_tok",	338,
	"rshift_assign_tok",	339,
	"lshift_assign_tok",	340,
	"slash_tok",	341,
	"slash_assign_tok",	342,
	"star_tok",	343,
	"star_assign_tok",	344,
	"semicolon_tok",	345,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"command_sequence : /* empty */",
	"command_sequence : command semicolon_tok command_sequence",
	"command : commit_tok",
	"command : reset_tok",
	"command : exit_tok",
	"command : quit_tok",
	"command : help_command",
	"command : schema_command",
	"command : endversion_tok",
	"command : wait_tok",
	"command : error",
	"help_command : help_tok",
	"help_command : help_tok period_tok help_topic",
	"help_topic : schema_tok",
	"help_topic : type_tok",
	"help_topic : enum_tok",
	"help_topic : typedef_tok",
	"help_topic : extern_tok",
	"help_topic : class_tok",
	"help_topic : method_tok",
	"help_topic : comp_tok",
	"schema_command : schema_with_name_command",
	"schema_command : schema_without_name_command",
	"schema_without_name_command : schema_tok period_tok schema_without_name_suffix",
	"schema_without_name_suffix : print_tok",
	"schema_without_name_suffix : create_tok name_param",
	"schema_without_name_suffix : remove_tok l_par_tok name opt_recursive r_par_tok",
	"opt_recursive : /* empty */",
	"opt_recursive : comma_tok recursive_tok",
	"schema_with_name_command : schema_tok schema_param period_tok",
	"schema_with_name_command : schema_tok schema_param period_tok schema_with_name_suffix",
	"schema_with_name_suffix : nname_tok period_tok set_tok name_param",
	"schema_with_name_suffix : with_extern_tok period_tok set_or_reset",
	"schema_with_name_suffix : generate_tok opt_name_param",
	"schema_with_name_suffix : import_command",
	"schema_with_name_suffix : print_tok",
	"schema_with_name_suffix : type_command",
	"schema_with_name_suffix : prot_gen_tok period_tok set_or_reset",
	"import_command : import_tok period_tok import_suffix",
	"import_suffix : insert_tok schema_param",
	"import_suffix : remove_tok schema_param",
	"import_suffix : update_tok schema_param",
	"import_suffix : update_tok",
	"type_command : command_valid_for_all_types",
	"type_command : enum_command",
	"type_command : union_command",
	"type_command : class_command",
	"type_command : extern_command",
	"type_command : typedef_command",
	"command_valid_for_all_types : type_kind period_tok create_tok opt_name_param",
	"command_valid_for_all_types : type_kind period_tok remove_tok name_param",
	"set_name_command_suffix : nname_tok period_tok set_tok name_param",
	"print_type_command_suffix : print_tok",
	"type_kind : enum_tok",
	"type_kind : union_tok",
	"type_kind : class_tok",
	"type_kind : extern_tok",
	"type_kind : typedef_tok",
	"enum_command : enum_tok name_param period_tok literal_tok period_tok insert_tok name_param",
	"enum_command : enum_tok name_param period_tok literal_tok period_tok remove_tok name_param",
	"enum_command : enum_tok name_param period_tok",
	"enum_command : enum_tok name_param period_tok print_type_command_suffix",
	"enum_command : enum_tok name_param period_tok",
	"enum_command : enum_tok name_param period_tok set_name_command_suffix",
	"union_command : union_tok name_param period_tok insert_tok type_param",
	"union_command : union_tok name_param period_tok remove_tok type_param",
	"union_command : union_tok name_param period_tok",
	"union_command : union_tok name_param period_tok print_type_command_suffix",
	"union_command : union_tok name_param period_tok",
	"union_command : union_tok name_param period_tok set_name_command_suffix",
	"class_command : class_tok name_param period_tok",
	"class_command : class_tok name_param period_tok class_command_suffix",
	"class_command : class_tok name_param period_tok",
	"class_command : class_tok name_param period_tok print_type_command_suffix",
	"class_command : class_tok name_param period_tok",
	"class_command : class_tok name_param period_tok set_name_command_suffix",
	"class_command_suffix : subclass_tok period_tok print_tok",
	"class_command_suffix : friend_tok period_tok remove_tok type_param",
	"class_command_suffix : friend_tok period_tok insert_tok type_param",
	"class_command_suffix : superclass_command",
	"class_command_suffix : component_command",
	"class_command_suffix : method_command",
	"class_command_suffix : instantiation_command",
	"class_command_suffix : create_par_command",
	"create_par_command : create_par_tok period_tok insert_tok l_par_tok name",
	"create_par_command : create_par_tok period_tok insert_tok l_par_tok name param_create_par_list r_par_tok",
	"create_par_command : create_par_tok period_tok remove_tok name_param",
	"create_par_command : create_par_tok int_param period_tok set_tok l_par_tok name",
	"create_par_command : create_par_tok int_param period_tok set_tok l_par_tok name param_create_par_list r_par_tok",
	"param_create_par_list : /* empty */",
	"param_create_par_list : comma_tok param_create_par param_create_par_list",
	"param_create_par : type_name",
	"param_create_par : init_expression",
	"param_create_par : number_tok",
	"superclass_command : super_tok period_tok insert_tok type_param",
	"superclass_command : super_tok period_tok remove_tok type_param",
	"superclass_command : super_tok type_param period_tok create_par_tok int_param period_tok set_tok expression_param",
	"component_command : comp_tok",
	"component_command : comp_tok comp_command_suffix",
	"comp_command_suffix : period_tok create_tok l_par_tok name comp_create_parameter_list r_par_tok",
	"comp_command_suffix : period_tok remove_tok comp_param",
	"comp_command_suffix : comp_param",
	"comp_command_suffix : comp_param period_tok comp_modif_command",
	"comp_param : name_param",
	"comp_modif_command : comp_attribute period_tok set_or_reset",
	"comp_modif_command : nname_tok period_tok set_tok name_param",
	"comp_modif_command : result_tok period_tok set_tok type_param",
	"comp_modif_command : init_tok period_tok set_tok expression_param",
	"comp_modif_command : scope_tok period_tok set_tok l_par_tok scope_modifier",
	"comp_modif_command : scope_tok period_tok set_tok l_par_tok scope_modifier r_par_tok",
	"comp_modif_command : scope_tok period_tok set_tok l_par_tok scope_modifier comma_tok scope_modifier set_tok",
	"comp_modif_command : scope_tok period_tok set_tok l_par_tok scope_modifier comma_tok scope_modifier set_tok r_par_tok",
	"comp_attribute : method_attribute",
	"comp_attribute : local_tok",
	"method_attribute : static_tok",
	"method_attribute : abstract_tok",
	"method_attribute : definite_tok",
	"scope_modifier : public_tok",
	"scope_modifier : protected_tok",
	"scope_modifier : private_tok",
	"scope_param : l_par_tok scope_modifier r_par_tok",
	"comp_create_parameter_list : /* empty */",
	"comp_create_parameter_list : comma_tok comp_create_parameter comp_create_parameter_list",
	"comp_create_parameter : type_name",
	"comp_create_parameter : init_expression",
	"comp_create_parameter : scope_modifier",
	"comp_create_parameter : scope_modifier set_tok",
	"comp_create_parameter : comp_attribute",
	"method_command : method_tok period_tok create_tok",
	"method_command : method_tok period_tok create_tok method_create_parameter_list",
	"method_command : method_tok period_tok remove_tok method_name_param",
	"method_command : method_tok method_name_param",
	"method_command : method_tok method_name_param period_tok method_command_with_name_suffix",
	"method_command_with_name_suffix : method_attribute period_tok set_or_reset",
	"method_command_with_name_suffix : scope_tok period_tok set_tok scope_param",
	"method_command_with_name_suffix : result_tok period_tok set_tok type_param",
	"method_command_with_name_suffix : nname_tok period_tok set_tok name_param",
	"method_command_with_name_suffix : param_tok method_param_modif_command",
	"method_param_modif_command : period_tok create_tok",
	"method_param_modif_command : period_tok create_tok l_par_tok name param_create_par_list r_par_tok",
	"method_param_modif_command : period_tok remove_tok int_param",
	"method_param_modif_command : int_param period_tok",
	"method_param_modif_command : int_param period_tok method_param_modif_command_suffix",
	"method_param_modif_command_suffix : type_tok period_tok set_tok type_param",
	"method_param_modif_command_suffix : ref_tok period_tok set_or_reset",
	"method_param_modif_command_suffix : nname_tok period_tok set_tok name_param",
	"method_param_modif_command_suffix : init_tok period_tok set_tok expression_param",
	"method_name_param : l_par_tok name r_par_tok",
	"method_name_param : l_par_tok name comma_tok number_tok r_par_tok",
	"method_create_parameter_list : l_par_tok name",
	"method_create_parameter_list : l_par_tok name method_create_parameters r_par_tok",
	"method_create_parameters : /* empty */",
	"method_create_parameters : comma_tok method_create_parameter method_create_parameters",
	"method_create_parameter : type_name",
	"method_create_parameter : scope_modifier",
	"method_create_parameter : method_attribute",
	"instantiation_command : instantiation_tok period_tok create_tok l_par_tok name comma_tok act_gen_par_list r_par_tok",
	"act_gen_par_list : l_abr_tok type_name_list r_abr_tok",
	"extern_command : extern_tok name_param period_tok size_tok period_tok set_tok int_param",
	"extern_command : extern_tok name_param period_tok",
	"extern_command : extern_tok name_param period_tok print_type_command_suffix",
	"extern_command : extern_tok name_param period_tok",
	"extern_command : extern_tok name_param period_tok set_name_command_suffix",
	"typedef_command : typedef_tok name_param period_tok type_tok period_tok set_tok type_param",
	"typedef_command : typedef_tok name_param period_tok",
	"typedef_command : typedef_tok name_param period_tok print_type_command_suffix",
	"typedef_command : typedef_tok name_param period_tok",
	"typedef_command : typedef_tok name_param period_tok set_name_command_suffix",
	"int_param : l_par_tok number_tok r_par_tok",
	"schema_param : name_param",
	"name : name_tok",
	"name_param : l_par_tok name_tok r_par_tok",
	"opt_name_param : /* empty */",
	"opt_name_param : name_param",
	"expression : number_tok",
	"expression : name",
	"set_or_reset : set_tok",
	"set_or_reset : reset_tok",
	"init_expression : assign_tok expression",
	"init_expression : assign_tok",
	"expression_param : l_par_tok expression r_par_tok",
	"type_param : l_par_tok type_name r_par_tok",
	"type_name : name",
	"type_name : name act_gen_par_list",
	"type_name_list : /* empty */",
	"type_name_list : type_name_list comma_tok type_name",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free((char*)yys); free((char*)yyv); return(0); }
#define YYABORT		{ free((char*)yys); free((char*)yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
extern int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

extern int yynerrs;			/* number of errors */

extern int yyerrflag;			/* error recovery flag */
extern int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 218 "src/mtools/msh.y"
{
	mta_commit();
#ifdef OBST_HAVE_PROT
	sos_ModifHistory::end_work();
#endif
     } break;
case 4:
# line 224 "src/mtools/msh.y"
{ mta_reset(); } break;
case 5:
# line 225 "src/mtools/msh.y"
{ exit (0);    } break;
case 6:
# line 226 "src/mtools/msh.y"
{ exit (0);    } break;
case 9:
# line 230 "src/mtools/msh.y"
{
#ifdef OBST_HAVE_PROT
	sos_ModifHistory::modif_history().end_version();
#endif
     } break;
case 10:
# line 235 "src/mtools/msh.y"
{ msh_wait_key(); } break;
case 12:
# line 240 "src/mtools/msh.y"
{ msh_help(); } break;
case 14:
# line 245 "src/mtools/msh.y"
{ help_schema();  } break;
case 15:
# line 246 "src/mtools/msh.y"
{ help_type();    } break;
case 16:
# line 247 "src/mtools/msh.y"
{ help_enum();    } break;
case 17:
# line 248 "src/mtools/msh.y"
{ help_typedef(); } break;
case 18:
# line 249 "src/mtools/msh.y"
{ help_extern();  } break;
case 19:
# line 250 "src/mtools/msh.y"
{ help_class();   } break;
case 20:
# line 251 "src/mtools/msh.y"
{ help_method();  } break;
case 21:
# line 252 "src/mtools/msh.y"
{ help_comp();    } break;
case 25:
# line 266 "src/mtools/msh.y"
{
	msh_list_schemas();
     } break;
case 26:
# line 270 "src/mtools/msh.y"
{
	sos_Schema_module::create_schema (yypvt[-0].str, FALSE);
     } break;
case 27:
# line 274 "src/mtools/msh.y"
{
	msh_schema = msh_sd [yypvt[-2].str];
	msh_schema.remove (yypvt[-1].b);
     } break;
case 28:
# line 281 "src/mtools/msh.y"
{ yyval.b = FALSE; } break;
case 29:
# line 282 "src/mtools/msh.y"
{ yyval.b = TRUE;  } break;
case 30:
# line 287 "src/mtools/msh.y"
{
        msh_schema = yypvt[-1].smdl;
        msh_cnt = msh_schema.container();
     } break;
case 32:
# line 296 "src/mtools/msh.y"
{
	 msh_schema.modify_name (yypvt[-0].str);
     } break;
case 33:
# line 300 "src/mtools/msh.y"
{
	msh_schema.modify_with_extern(yypvt[-0].b);
     } break;
case 34:
# line 304 "src/mtools/msh.y"
{
	msh_schema.generate (yypvt[-0].str); 
     } break;
case 36:
# line 309 "src/mtools/msh.y"
{
	mta_schema_declaration (cout, msh_schema);
     } break;
case 38:
# line 314 "src/mtools/msh.y"
{
#ifdef OBST_HAVE_PROT
	sos_ModifHistory::set_gen_prot (msh_schema, yypvt[-0].b);
#endif
     } break;
case 40:
# line 326 "src/mtools/msh.y"
{ msh_schema.insert_import (yypvt[-0].smdl); } break;
case 41:
# line 327 "src/mtools/msh.y"
{ msh_schema.remove_import (yypvt[-0].smdl); } break;
case 42:
# line 328 "src/mtools/msh.y"
{ msh_schema.update_import (yypvt[-0].smdl); } break;
case 43:
# line 329 "src/mtools/msh.y"
{ msh_schema.update_imports();   } break;
case 50:
# line 343 "src/mtools/msh.y"
{
	msh_schema.create_type (yypvt[-3].t, yypvt[-0].str);
     } break;
case 51:
# line 347 "src/mtools/msh.y"
{
	sos_Type_descr td = msh_schema.lookup_type (yypvt[-0].str);
	td.remove();
     } break;
case 52:
# line 355 "src/mtools/msh.y"
{
        msh_result_type.modify_name(sos_String::clone(yypvt[-0].str, msh_cnt));
     } break;
case 53:
# line 362 "src/mtools/msh.y"
{
        sos_String_List sl = mta_get_declaration(msh_result_type);
        agg_iterate (sl, sos_String s)
           cout << s << "\n";
        agg_iterate_end (sl, s)
        MTA_DESTROY_LIST (sl);
     } break;
case 54:
# line 372 "src/mtools/msh.y"
{ yyval.t = sos_Enum_type_type;    } break;
case 55:
# line 373 "src/mtools/msh.y"
{ yyval.t = sos_Union_type_type;   } break;
case 56:
# line 374 "src/mtools/msh.y"
{ yyval.t = sos_Class_type_type;   } break;
case 57:
# line 375 "src/mtools/msh.y"
{ yyval.t = sos_Extern_type_type;  } break;
case 58:
# line 376 "src/mtools/msh.y"
{ yyval.t = sos_Typedef_type_type; } break;
case 59:
# line 381 "src/mtools/msh.y"
{
	sos_Enum_type et = sos_Enum_type::make(msh_schema.lookup_type (yypvt[-5].str));
	et.insert_literal (yypvt[-0].str);
     } break;
case 60:
# line 386 "src/mtools/msh.y"
{
	sos_Enum_type et = sos_Enum_type::make (msh_schema.lookup_type (yypvt[-5].str));
	et.remove_literal (yypvt[-0].str);
     } break;
case 61:
# line 391 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 63:
# line 396 "src/mtools/msh.y"
{
        msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 65:
# line 404 "src/mtools/msh.y"
{
	sos_Union_type ut = sos_Union_type::make(msh_schema.lookup_type (yypvt[-3].str));
	ut.insert_type (yypvt[-0].td);
     } break;
case 66:
# line 409 "src/mtools/msh.y"
{
	sos_Union_type ut = sos_Union_type::make(msh_schema.lookup_type (yypvt[-3].str));
	ut.remove_type (yypvt[-0].td);
     } break;
case 67:
# line 414 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 69:
# line 419 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 71:
# line 427 "src/mtools/msh.y"
{
	msh_class = sos_Class_type::make (msh_schema.lookup_type (yypvt[-1].str));
     } break;
case 73:
# line 432 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 75:
# line 437 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 77:
# line 445 "src/mtools/msh.y"
{
	msh_list_subclasses (msh_class);
     } break;
case 78:
# line 449 "src/mtools/msh.y"
{
	msh_class.insert_friend (sos_Class_type::make (yypvt[-0].td));
     } break;
case 79:
# line 453 "src/mtools/msh.y"
{
	msh_class.remove_friend (sos_Class_type::make (yypvt[-0].td));
     } break;
case 85:
# line 465 "src/mtools/msh.y"
{
	// set defaults for create parameter insertion
	msh_result_type = sos_Type_descr::make(void_type);
	msh_init_expr   = sos_Expr::make (NO_OBJECT);
	msh_integer	= 1;
     } break;
case 86:
# line 472 "src/mtools/msh.y"
{
	msh_class.insert_create_param (yypvt[-3].str, msh_result_type, msh_init_expr,
				       msh_integer);
     } break;
case 87:
# line 477 "src/mtools/msh.y"
{
	msh_class.remove_create_param (yypvt[-0].str);
     } break;
case 88:
# line 481 "src/mtools/msh.y"
{
	// set defaults for create parameter modification
	sos_Param p     = msh_class.get_create_params().get_nth(yypvt[-4].i);
	msh_result_type = p.get_type();
	msh_init_expr   = p.get_default_expr();
     } break;
case 89:
# line 488 "src/mtools/msh.y"
{
	msh_class.modify_create_param (yypvt[-7].i, yypvt[-3].str, msh_result_type, msh_init_expr);
     } break;
case 92:
# line 499 "src/mtools/msh.y"
{ msh_result_type = yypvt[-0].td; } break;
case 93:
# line 500 "src/mtools/msh.y"
{ msh_init_expr   = yypvt[-0].exp; } break;
case 94:
# line 501 "src/mtools/msh.y"
{ msh_integer     = yypvt[-0].i; } break;
case 95:
# line 506 "src/mtools/msh.y"
{
	msh_class.insert_superclass (yypvt[-0].td);
     } break;
case 96:
# line 510 "src/mtools/msh.y"
{
	msh_class.remove_superclass (yypvt[-0].td);
     } break;
case 97:
# line 515 "src/mtools/msh.y"
{
	msh_class.modify_superclass_create_param (yypvt[-6].td, yypvt[-3].i, yypvt[-0].exp);
     } break;
case 98:
# line 522 "src/mtools/msh.y"
{
	msh_init_expr   = sos_Expr::make (NO_OBJECT);
	msh_result_type = sos_Type_descr::make(void_type);
	msh_get_scope   =
	msh_set_scope   = sos_PRIVATE;
	msh_is_static   =
	msh_is_local    =
	msh_is_abstract =
	msh_is_definite = FALSE;
     } break;
case 100:
# line 538 "src/mtools/msh.y"
{
	sos_Comp_descr cd = msh_class.create_component();
	cd.modify (yypvt[-2].str, msh_result_type, msh_get_scope, msh_set_scope,
		   msh_is_local, msh_is_definite, msh_is_static, msh_init_expr);
     } break;
case 101:
# line 544 "src/mtools/msh.y"
{
	yypvt[-0].cd.remove();
     } break;
case 102:
# line 548 "src/mtools/msh.y"
{
	msh_cd = yypvt[-0].cd;
	msh_name        = msh_cd.get_name();
	msh_init_expr   = msh_cd.get_init_expr();
	msh_result_type = msh_cd.get_get_method().get_result_type();
	msh_get_scope   = msh_cd.get_get_method().get_kind();
	msh_set_scope   = msh_cd.get_set_method().get_kind();
	msh_is_static   = FALSE;
	msh_is_local    = msh_cd.get_is_local();
	msh_is_abstract = msh_cd.get_get_method().get_is_abstract();
	msh_is_definite = msh_cd.get_get_method().get_is_definite();
     } break;
case 103:
# line 561 "src/mtools/msh.y"
{
	msh_cd.modify (msh_name, msh_result_type, msh_get_scope, msh_set_scope,
		       msh_is_local, msh_is_definite, msh_is_static,
		       msh_init_expr);
     } break;
case 104:
# line 570 "src/mtools/msh.y"
{
        sos_Comp_descr_List comps = msh_class.get_components();
        agg_iterate (comps, sos_Comp_descr cd)
        {  if (    cd.get_name().equal (yypvt[-0].str)
	       AND cd.get_get_method().get_defined_in().operator==(msh_class))
	   {  yyval.cd = cd;
	      break;
	   }
        }
        agg_iterate_end (comps, cd)
     } break;
case 105:
# line 584 "src/mtools/msh.y"
{ *yypvt[-2].b_poi		    = yypvt[-0].b; } break;
case 106:
# line 585 "src/mtools/msh.y"
{ msh_name        = yypvt[-0].str; } break;
case 107:
# line 586 "src/mtools/msh.y"
{ msh_result_type = yypvt[-0].td; } break;
case 108:
# line 587 "src/mtools/msh.y"
{ msh_init_expr   = yypvt[-0].exp; } break;
case 109:
# line 589 "src/mtools/msh.y"
{
	msh_get_scope =
	msh_set_scope = yypvt[-0].mk;
     } break;
case 111:
# line 596 "src/mtools/msh.y"
{
	msh_get_scope = yypvt[-3].mk;
	msh_set_scope = yypvt[-1].mk;
     } break;
case 114:
# line 605 "src/mtools/msh.y"
{ msh_is_local    = TRUE; yyval.b_poi = &msh_is_local;    } break;
case 115:
# line 609 "src/mtools/msh.y"
{ msh_is_static   = TRUE; yyval.b_poi = &msh_is_static;   } break;
case 116:
# line 610 "src/mtools/msh.y"
{ msh_is_abstract = TRUE; yyval.b_poi = &msh_is_abstract; } break;
case 117:
# line 611 "src/mtools/msh.y"
{ msh_is_definite = TRUE; yyval.b_poi = &msh_is_definite; } break;
case 118:
# line 615 "src/mtools/msh.y"
{ yyval.mk = sos_PUBLIC;    } break;
case 119:
# line 616 "src/mtools/msh.y"
{ yyval.mk = sos_PROTECTED; } break;
case 120:
# line 617 "src/mtools/msh.y"
{ yyval.mk = sos_PRIVATE;   } break;
case 121:
# line 621 "src/mtools/msh.y"
{ yyval.mk = yypvt[-1].mk; } break;
case 124:
# line 630 "src/mtools/msh.y"
{ msh_result_type = yypvt[-0].td; } break;
case 125:
# line 631 "src/mtools/msh.y"
{ msh_init_expr   = yypvt[-0].exp; } break;
case 126:
# line 632 "src/mtools/msh.y"
{ msh_get_scope   =
			      msh_set_scope   = yypvt[-0].mk; } break;
case 127:
# line 634 "src/mtools/msh.y"
{ msh_set_scope   = yypvt[-1].mk; } break;
case 129:
# line 640 "src/mtools/msh.y"
{
	msh_scope       = sos_PRIVATE;
	msh_is_abstract =
	msh_is_definite =
	msh_is_static   = FALSE;
	msh_result_type = sos_Type_descr::make (void_type);
     } break;
case 130:
# line 648 "src/mtools/msh.y"
{
	msh_method = msh_class.create_method();
	msh_method.modify (msh_result_type, msh_name, msh_scope,
			   msh_is_static, msh_is_abstract, msh_is_definite);
     } break;
case 131:
# line 654 "src/mtools/msh.y"
{
	yypvt[-0].md.remove();
     } break;
case 132:
# line 658 "src/mtools/msh.y"
{
	msh_method      = yypvt[-0].md;
	msh_result_type = msh_method.get_result_type();
	msh_name        = msh_method.get_name();
	msh_is_static   = msh_method.get_is_static();
	msh_is_definite = msh_method.get_is_definite();
	msh_is_abstract = msh_method.get_is_abstract();
	msh_scope       = msh_method.get_kind();
     } break;
case 134:
# line 672 "src/mtools/msh.y"
{
	*yypvt[-2].b_poi = yypvt[-0].b;
	msh_method.modify (msh_result_type, msh_name, msh_scope,
			   msh_is_static, msh_is_abstract, msh_is_definite);
     } break;
case 135:
# line 678 "src/mtools/msh.y"
{
	msh_method.modify (msh_result_type, msh_name, yypvt[-0].mk,
			   msh_is_static, msh_is_abstract, msh_is_definite);
     } break;
case 136:
# line 683 "src/mtools/msh.y"
{
	msh_result_type = yypvt[-0].td;
	msh_method.modify (msh_result_type, msh_name, msh_scope,
			   msh_is_static, msh_is_abstract, msh_is_definite);
     } break;
case 137:
# line 689 "src/mtools/msh.y"
{
	msh_method.modify (msh_result_type, yypvt[-0].str, msh_scope,
			   msh_is_static, msh_is_abstract, msh_is_definite);
     } break;
case 139:
# line 698 "src/mtools/msh.y"
{
	msh_result_type = sos_Type_descr::make (void_type);
	msh_integer     = 1;
	msh_init_expr   = sos_Expr::make (NO_OBJECT);
     } break;
case 140:
# line 704 "src/mtools/msh.y"
{
	msh_method.insert_param (msh_integer, msh_result_type);
	msh_method.modify_param (msh_integer, msh_result_type,
				 yypvt[-2].str, FALSE, msh_init_expr);
     } break;
case 141:
# line 710 "src/mtools/msh.y"
{
	msh_method.remove_param (yypvt[-0].i);
     } break;
case 142:
# line 714 "src/mtools/msh.y"
{
	msh_param	 = msh_method.get_params().get_nth (yypvt[-1].i);
	msh_result_type  = msh_param.get_type();
	msh_init_expr    = msh_param.get_default_expr();
	msh_is_reference = msh_param.get_is_ref();
	msh_name	 = msh_param.get_name();
     } break;
case 143:
# line 722 "src/mtools/msh.y"
{
	msh_method.modify_param (yypvt[-3].i, msh_result_type,
				 msh_name, msh_is_reference, msh_init_expr);
     } break;
case 144:
# line 729 "src/mtools/msh.y"
{ msh_result_type  = yypvt[-0].td; } break;
case 145:
# line 730 "src/mtools/msh.y"
{ msh_is_reference = yypvt[-0].b; } break;
case 146:
# line 731 "src/mtools/msh.y"
{ msh_name         = yypvt[-0].str; } break;
case 147:
# line 732 "src/mtools/msh.y"
{ msh_init_expr    = yypvt[-0].exp; } break;
case 148:
# line 737 "src/mtools/msh.y"
{
	yyval.md = msh_lookup_method(msh_class, yypvt[-1].str);
     } break;
case 149:
# line 741 "src/mtools/msh.y"
{
        yyval.md = msh_lookup_method(msh_class, yypvt[-3].str, yypvt[-1].i);
     } break;
case 150:
# line 747 "src/mtools/msh.y"
{ msh_name = yypvt[-0].str; } break;
case 154:
# line 756 "src/mtools/msh.y"
{ msh_result_type = yypvt[-0].td; } break;
case 155:
# line 757 "src/mtools/msh.y"
{ msh_scope       = yypvt[-0].mk; } break;
case 158:
# line 767 "src/mtools/msh.y"
{ yyval.td_l = yypvt[-1].td_l; } break;
case 159:
# line 772 "src/mtools/msh.y"
{
	sos_Extern_type et = sos_Extern_type::make(msh_schema.lookup_type(yypvt[-5].str));
	et.modify_size (yypvt[-0].i);
     } break;
case 160:
# line 777 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 162:
# line 782 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 164:
# line 790 "src/mtools/msh.y"
{
	sos_Typedef_type td= sos_Typedef_type::make(msh_schema.lookup_type(yypvt[-5].str));
	td.modify (yypvt[-0].td);
     } break;
case 165:
# line 795 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 167:
# line 800 "src/mtools/msh.y"
{
	msh_result_type = msh_schema.lookup_type(yypvt[-1].str);
     } break;
case 169:
# line 807 "src/mtools/msh.y"
{ yyval.i = yypvt[-1].i; } break;
case 170:
# line 811 "src/mtools/msh.y"
{ yyval.smdl = msh_sd [yypvt[-0].str]; } break;
case 171:
# line 815 "src/mtools/msh.y"
{ yyval.str = sos_String::create (TEMP_CONTAINER, yypvt[-0].s); } break;
case 172:
# line 820 "src/mtools/msh.y"
{
        yyval.str = sos_String::create (TEMP_CONTAINER, yypvt[-1].s);
     } break;
case 173:
# line 826 "src/mtools/msh.y"
{ yyval.str = sos_String::make(NO_OBJECT); } break;
case 175:
# line 831 "src/mtools/msh.y"
{ yyval.exp = sos_Int_expr::create  (TEMP_CONTAINER, yypvt[-0].i); } break;
case 176:
# line 832 "src/mtools/msh.y"
{ yyval.exp = sos_Identifier::create(TEMP_CONTAINER, yypvt[-0].str); } break;
case 177:
# line 836 "src/mtools/msh.y"
{ yyval.b = TRUE;  } break;
case 178:
# line 837 "src/mtools/msh.y"
{ yyval.b = FALSE; } break;
case 179:
# line 841 "src/mtools/msh.y"
{ yyval.exp = yypvt[-0].exp;			     } break;
case 180:
# line 842 "src/mtools/msh.y"
{ yyval.exp = sos_Expr::make(NO_OBJECT); } break;
case 181:
# line 846 "src/mtools/msh.y"
{ yyval.exp = yypvt[-1].exp; } break;
case 182:
# line 850 "src/mtools/msh.y"
{ yyval.td = yypvt[-1].td; } break;
case 183:
# line 855 "src/mtools/msh.y"
{
	yyval.td = msh_schema.lookup_type (yypvt[-0].str);
	if (INVALID (yyval.td))
	   msh_error (err_USE, err_MSH_TYPE_NOT_FOUND, yypvt[-0].str);
     } break;
case 184:
# line 861 "src/mtools/msh.y"
{
	sos_Type_descr td = msh_schema.lookup_type (yypvt[-1].str);
	sos_Class_type ct = sos_Class_type::make (td);
	yyval.td = ct.lookup_or_create_instantiation (msh_schema, yypvt[-0].td_l, TRUE);
     } break;
case 185:
# line 869 "src/mtools/msh.y"
{
	yyval.td_l = sos_Type_descr_List::create (TEMP_CONTAINER);
     } break;
case 186:
# line 873 "src/mtools/msh.y"
{
        yypvt[-2].td_l.append(yypvt[-0].td);
        yyval.td_l = yypvt[-2].td_l;
     } break;
	}
	goto yystack;		/* reset registers in driver code */
}
