/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

/* ========================================================================= */
/* MODULE IMPLEMENTATION                                                     */
/* ========================================================================= */
/*                                                                           */
/* MODULE : sync_decl.h                                                      */
/*                                                                           */
/* ORIGINAL                                                                  */
/* AUTHOR: Axel Freyberg                       DATE: 23.03.1992              */
/*                                                                           */
/* CHANGES: see .changes                                                     */
/*                                                                           */
/* VERSION: none                                                             */
/* ========================================================================= */

#include "trc_tsy.h"

/* ========================================================================= */
/* INTERNAL CONSTANTS                                                        */
/* ========================================================================= */
#define  NO_TS (sos_Timestamp)0       
					// Initial value of Timemarks
#define  SOS_OLD_TA_TS       10       
					// minimal number of ta started since
                                      	// opt. ta to be an old opt ta

/* ========================================================================= */
/* GLOBAL VARIABLES                                                          */
/* ========================================================================= */

extern sos_Bool sync_deadlock;
