/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

/* ========================================================================= */
/* MODULE DEFINITION                                                         */
/* ========================================================================= */
/*                                                                           */
/* MODULE : SYNC_err.h                                                       */
/*                                                                           */
/* ORIGINAL                                                                  */
/* AUTHOR: Axel Freyberg                       DATE: 01.07.1992              */
/*                                                                           */
/* CHANGES: see .changes                                                     */
/*                                                                           */
/* VERSION: none                                                             */
/* ========================================================================= */

#ifndef ERRSYNCH
#define ERRSYNCH 1

#include "obst_err.h"

extern const err_msg ERR;
extern const err_msg err_SYNC_NO_SYNC_CONTAINER; // synccont (psm)
extern const err_msg err_SYNC_NO_SYCT_ROOT;
extern const err_msg err_SYNC_TA_NOT_EXISTS; // ??? cannot happen
extern const err_msg err_SYNC_NO_CREATE_SYNCOBJ;
extern const err_msg err_SYNC_NO_CREATE_IMPLICIT_TA;
extern const err_msg err_SYNC_PATH_TOO_LONG;
extern const err_msg err_SYNC_NO_CONTAINER_PATH;
extern const err_msg err_SYNC_PIDFILE_CREATE;
extern const err_msg err_SYNC_PIDFILE_LOCK;
extern const err_msg err_SYNC_PIDFILE_OPEN;
extern const err_msg err_SYNC_NOTA_PROCESS;
extern const err_msg err_SYNC_ACTIVATE_ERR;
extern const err_msg err_SYNC_TOO_MANY_HOST;
extern const err_msg err_SYNC_SOCKET;
#endif
