#ifndef _TRC_KNL_H
#define _TRC_KNL_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_trc.h"

#define knl_H  30
#define knl_M  31
#define knl_L  32
#define knl_VL 33

// Tracing conventions:
//      no tracing: module initialization, external type conversions,
//                  local offset handling, kernel type access,
//                  C++ classes (except for allocation),
//                  access to container, offset, typed ID.
//      knl_M     : generic conversions, container storage allocation,
//                  external utility methods, local_... methods
//      knl_H     : other methods

#endif
