#ifndef _TRC_PSM_H
#define _TRC_PSM_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_trc.h"

#define psm_H              20
#define psm_M              21
#define psm_L              22
#define psm_VL             23
#define psm_CHECK_READ     24
#define psm_CHECK_WRITE    25
#define psm_CNT_STATS      26
#define psm_CNT_STATS_FULL 27

// Tracing conventions:
//      psm_VL:
//      psm_L :
//      psm_M :
//      psm_H :
//      psm_CNT_STATS:      collect basic container statistics
//      psm_CNT_STATS_FULL: collect `expensive' container statistics

#endif
