#ifndef _TRC_SCP_H
#define _TRC_SCP_H 1
/* --------------------------------------------------------------------------
 * Copyright 1994-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_trc.h"

// since scp is not part of the library, its trace switches may/might overlap
// with the switches used in other OBST programs

#define scp_H  150
#define scp_M  151
#define scp_L  152
#define scp_VL 153

// Tracing conventions:
//                  
//      no tracing:
//      scp_H	  : high level substitutions
//	scp_M	  : meta schema interface, basic substitutions
//	scp_L	  : yacc error messages
//	scp_VL	  : classes strings, ParamList

#endif /* _TRC_SCP_H */
