/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include "sfb_use.h"
#include "obst_err.h"
#include "obst.h"

// this file contains the conversion operations 
// for the stf grammar sfb


sos_Type convertstring (sos_String s) {

  sos_Extern_type result = sos_Extern_type::create(TEMP_CONTAINER);
  result.set_name(s);
  return result;

}

sos_String unconvertstring (sos_Type type) {

   sos_String result = sos_String::create(TEMP_CONTAINER);
   result = type.get_name();
   return result; 

}
