/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define OBST_IMP_STREAM
#include "obst_stdinc.h"

#include "obst.h"
#include "../UnixFile/UnixFile_use.h"
#include "../include/string_utils.h"

int main (int argc, char* argv[])
{  obst_init (argc, argv);

   ROOT_CONTAINER.open (WRITING, WAITING);

   sos_String no_name = sos_String::make (NO_OBJECT);
   UnixFile f1 = UnixFile::create (ROOT_CONTAINER, no_name);

   f1.rename ("test");

   cout << "f1's new name is " << f1.get_name() << "\n";

   ROOT_CONTAINER.close();

   return 0;
}
  
