/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include "UnixFile_obst.h"

void UnixFile::append (UnixFile f)
{ self.set_size(self.get_size() + f.get_size()); }

void UnixFile::rename (sos_Cstring s)
{ self.get_name().assign_Cstring (s); }

void UnixFile::local_initialize (UnixFile f)
{  if (f.get_name() == NO_OBJECT)
   {  sos_String default_name = sos_String::create (f.container());
      default_name.assign_Cstring ("DEFAULT_FILE_NAME");
      f.set_name (default_name);
   }
}
void UnixFile::local_finalize (UnixFile f)
{  f.get_name().destroy(); }
