#ifndef _CCI_ERR_H
#define _CCI_ERR_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include "obst_err.h"

extern const err_msg err_CCI_INC_LOAD_FAILED;
extern const err_msg err_CCI_INC_LOAD_NOT_IMPL;
extern const err_msg err_CCI_INC_LOAD_NO_LOADFCT;
extern const err_msg err_CCI_INVALID_OBJ;
extern const err_msg err_CCI_INVALID_METHOD;
extern const err_msg err_CCI_LINK_FAILED;
extern const err_msg err_CCI_LOAD_FAILED;
extern const err_msg err_CCI_MKEXEC_FAILED;
extern const err_msg err_CCI_MOVE_FAILED;
extern const err_msg err_CCI_NOT_INITIALIZED;
extern const err_msg err_CCI_NOT_STATIC;
extern const err_msg err_CCI_NO_DEPENDENCIES;
extern const err_msg err_CCI_NO_LOAD_IN_BOOT;
extern const err_msg err_CCI_OPEN_FAILED;
extern const err_msg err_CCI_READ_FAILED;
extern const err_msg err_CCI_READ_HEADER_FAILED;
extern const err_msg err_CCI_SEEK_FAILED;
extern const err_msg err_CCI_TYPE_ERROR;
extern const err_msg err_CCI_UNKNOWN_SCHEMA;
extern const err_msg err_CCI_WRITE_FAILED;
extern const err_msg err_CCI_WRONG_INIT;

extern const err_msg err_SIL_NO_SCHEMA;
extern const err_msg err_SIL_USAGE;

#endif /* _CCI_ERR_H */
