#ifndef _OBST_H
#define _OBST_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include "obst_config.h"

#ifdef __cplusplus
extern "C" {
#endif

#define obst_STATIC_INIT(stat,expr)    (_obst_initcore(),(stat),(expr))
#define obst_CORELIB_STATIC_INIT(expr) (_obst_initcore(),(expr))


extern const char	*obst_tempdir;
extern const char	*obst_version;
extern int		obst_initialized;
extern char*		_obst_bootschemas[];

/* force a reference to the static part of the OBST shared library */
extern int		__obst_dummy;
#define obst_init(a,b)	{__obst_dummy=(a);_obst_init(__obst_dummy,(b));}

extern void  _obst_init  __FSIG_((int argc, char* argv[]));
extern char* obst_getenv __FSIG_((char*));

#ifdef __cplusplus
}
#endif

#if defined(__cplusplus) && defined(OBST_HAVE_JOYCE)
			/* don't move this from the end: g++ will */
#include "trans_use.h"	/* raise errors; don't know why, mr 27.1.93 */

extern sos_Transaction	TRANSACTION;
#endif

#endif
