#ifndef _OBST_SYS_H
#define _OBST_SYS_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#define MOD      %
#define AND      &&
#define OR       ||
#define NOT      !
#define EQ       ==
#define NEQ      !=
#define PTR      *
#define REF(x)  (&(x))
#define CONT(x) (*(x))
 
#define BITAND      &
#define BITOR       |
#define BITXOR      ^
#define BITCPL(x) ~(x)

#define SMALL(n)     (char)( (n) & 0x80) ? (~0x7F|(n)) : (n))
#define USMALL(n)    (unsigned)((n) & 0xFF)
#define RSHIFT(n,b)  ((b<(sizeof(n)*8)) ? (unsigned) (n)>>(b) : 0)
#define LSHIFT(n,b)  ((b<(sizeof(n)*8)) ? (n)<<(b) : 0)

#define EXPORT
#define LOCAL    static
 
#define EOL      '\n'
#define EOS      '\0'
#define TAB      '\t'
#define FF       '\f'

#define streql   NOT strcmp
#define streqln  NOT strncmp
				 /* ATT2.0 QUEERNESS: explicit operator */
#define VALID(a)   ((a).operator!=(NO_OBJECT))
#define INVALID(a) ((a).operator==(NO_OBJECT))

#endif
