#ifndef _PROT_ERR_H
#define _PROT_ERR_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the licence
 * you should have received along with this program.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * D-76131 Karlsruhe 1, Germany.
 * --------------------------------------------------------------------------
 */

#include "obst_err.h"

extern const err_msg prot_ERR; 
extern const err_msg err_PROT_SUPERCLASS_ADD;
extern const err_msg err_PROT_SUPERCLASS_DEL;
extern const err_msg err_PROT_FRIEND_NO_CLASS;
extern const err_msg err_PROT_COMP_DEL;
extern const err_msg err_PROT_PARAM_DEL;
extern const err_msg err_PROT_SCHEMAMODIF_NOT_KNOWN;
extern const err_msg err_PROT_SCHEMA_ADDMOD;
extern const err_msg err_PROT_TYPE_ADDMOD;
extern const err_msg err_PROT_RENTYPE_DEL;

#endif /* _PROT_ERR_H */
