#ifndef _CFE_ERR_H
#define _CFE_ERR_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the licence
 * you should have received along with this program.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_err.h"

extern const err_msg err_CFE_AMBIGUOUS_GEN_PARAMS;
extern const err_msg err_CFE_AMBIGUOUS_METHODS;
extern const err_msg err_CFE_ASSIGN_WITHOUT_EQUAL;
extern const err_msg err_CFE_CLASS_EXPECTED;
extern const err_msg err_CFE_EQUAL_WITHOUT_HASH;
extern const err_msg err_CFE_L_AND_T_ASSIGN;
extern const err_msg err_CFE_L_AND_T_EQUAL;
extern const err_msg err_CFE_L_AND_T_HASH;
extern const err_msg err_CFE_L_AND_T_FINALIZE;
extern const err_msg err_CFE_L_AND_T_INIT;
extern const err_msg err_CFE_FULL_GENERIC;
extern const err_msg err_CFE_GEN_PARAM_MISMATCH;
extern const err_msg err_CFE_FORWD_AS_ACT_GEN;
extern const err_msg err_CFE_MANY_CREATE_PARAMS;
extern const err_msg err_CFE_FEW_CREATE_PARAMS;
extern const err_msg err_CFE_INVALID_CREATE_PARAMS;
extern const err_msg err_CFE_GENERIC_TYPE_EXPECTED;
extern const err_msg err_CFE_INTERNAL;
extern const err_msg err_CFE_INVALID_EXT_SIZE;
extern const err_msg err_CFE_INVALID_IMPORT;
extern const err_msg err_CFE_INVALID_LOCAL_METHOD;
extern const err_msg err_CFE_INVALID_OVERLOADING;
extern const err_msg err_CFE_INVALID_REDEFINITION;
extern const err_msg err_CFE_INVALID_ACCESS_RESTR;
extern const err_msg err_CFE_DEFINITE_REDEFINED;
extern const err_msg err_CFE_DEFAULT_FOR_REFERENCE;
extern const err_msg err_CFE_INVALID_TYPE_LIST;
extern const err_msg err_CFE_LEXICAL_ERROR;
extern const err_msg err_CFE_MULTIPLE_TYPE_DECL;
extern const err_msg err_CFE_NO_FILE;
extern const err_msg err_CFE_NO_GENERIC_TYPE;
extern const err_msg err_CFE_NO_KERNEL;
extern const err_msg err_CFE_NO_RESERVED_SCHEMA_NAME;
extern const err_msg err_CFE_NOT_DECLARED;
extern const err_msg err_CFE_RESERVED_SCHEMA_NAME;
extern const err_msg err_CFE_SCRAMBLED_INSTANTIATION;
extern const err_msg err_CFE_TOO_MANY_LITERALS;
extern const err_msg err_CFE_UNDECL_CLASS;
extern const err_msg err_CFE_UNKNOWN_SUPERCLASS;
extern const err_msg err_CFE_UNKNOWN_GENERIC_CLASS;
extern const err_msg err_CFE_FORMAL_AS_SUPERCLASS;
extern const err_msg err_CFE_MULTIPLE_SUPERCLASS;
extern const err_msg err_CFE_USAGE;
extern const err_msg err_CFE_PRIVATE_METHOD_ABSTRACT;
extern const err_msg err_CFE_ABSTRACT_COMP;

extern const err_msg err_CFE_NO_DEFINITE_FUNCS;
extern const err_msg err_CFE_NO_LOCAL_FUNCS;
extern const err_msg err_CFE_NO_VALUE_FUNCS;
extern const err_msg err_CFE_NO_DEFINITE_COMPS;
extern const err_msg err_CFE_NO_STATIC_COMPS;
extern const err_msg err_CFE_NO_VALUE_COMPS;

#endif /* _CFE_ERR_H */
