#ifndef _GTOOLS_ERR_H
#define _GTOOLS_ERR_H 1

/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */

#include "obst_err.h"

// --------------------------- common --------------------------

extern const err_msg err_GTOOLS_INVALID_ROOT;

// --------------------------- gsh -----------------------------

extern const err_msg err_GSH_USAGE;

// --------------------------- dir -----------------------------

extern const err_msg err_DIR_USAGE;

#endif /* _GTOOLS_ERR_H */
