#ifndef _PSM_MON_H
#define _PSM_MON_H 1
/* -----------------------------------------------------------------------------
* Copyright 1992-1994 by Forschungszentrum Informatik(FZI)
 * All rights reserved.
*
* You can use and distribute this software under the terms of the license
* you should have received along with this software.
* For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
* Email: obst@xcc-ka.de.
* ------------------------------------------------------------------------------
*/
// *****************************************************************************
// Module psm                  Emil Sekerinski, Oliver Spatscheck, Walter Zimmer
//
// *****************************************************************************
//  persistent storage manager: monitor header 
// *****************************************************************************


#ifdef MONITOR

// *****************************************************************************
// TYPEDEFS 
// *****************************************************************************

typedef unsigned mon_win;

// *****************************************************************************
// FUNCTION DECLARATIONS
// *****************************************************************************

extern void mon_black(mon_win w, int n);
extern void mon_close(mon_win w);
extern mon_win mon_create(int cid, int last);
extern void mon_destroy(mon_win w);
extern void mon_grey(mon_win w, int n);
extern void mon_initialize();
extern void mon_open(mon_win w, int rw, char* title);
extern void mon_white(mon_win w, int n);

// *****************************************************************************
// DATA DECLARATIONS
// *****************************************************************************

extern sos_Bool mon_activated;

#endif
#endif
