#ifndef _TRC_CCI_H
#define _TRC_CCI_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_trc.h"

#define cci_H  70
#define cci_M  71
#define cci_L  72
#define cci_VL 73

// Tracing conventions:
//      no tracing: string conversions for external types, statistics

//      cci_VL: symbol table handling, utility routines for loading
//      cci_L : hash table management
//      cci_M : module initialization, local_... methods, load
//      cci_H : other methods

#endif
