#ifndef _TRC_GENCC_H
#define _TRC_GENCC_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_trc.h"

#define genCC_H  100
#define genCC_M  101
#define genCC_L  102
#define genCC_VL 103

// Tracing conventions:
//      genCC_H : methods of the frontend 
//      genCC_M : methods generating the schema, types and methods
//                (most backend methods, code_additional_methods and
//                 code_param_list)
//      genCC_L : methods generating method bodies
//                (most code_... methods) 
//      genCC_VL: other methods

#endif



