/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "stf_err.h"

const err_msg err_STF_USAGE="usage: stf [-E] [-NOSTR] [-NOFLT] [-P] (-G <grammar> | <file>)";
const err_msg err_STF_NO_FILE="no file";
const err_msg err_STF_NO_GRAMMAR="no grammar";
const err_msg err_STF_LEXICAL_ERROR="lexical error";
const err_msg err_STF_NO_TYPE="type name expected";
const err_msg err_STF_NO_LIST_TYPE="list type name expected";
const err_msg err_STF_NO_CLASS="class name expected";
const err_msg err_STF_NO_SYMBOL="symbol name expected";
const err_msg err_STF_NO_COMP="component name expected";
const err_msg err_STF_NO_SCHEMA="schema name expected";
const err_msg err_STF_UNDEFINED_SYMBOL="undefined symbol";
const err_msg err_STF_OUTPUT_ERROR="error in opening file";
const err_msg err_STF_INCOMPATIBLE_TYPES="types incompatible for derivation";
const err_msg err_STF_AMBIGUOUS_FLATTENING="warning for ambiguous flattening";
