#ifndef _STF_ERR_H
#define _STF_ERR_H 1
/* --------------------------------------------------------------------------
 * Copyright 1992-1994 by Forschungszentrum Informatik (FZI)
 * All rights reserved.
 *
 * You can use and distribute this software under the terms of the license
 * you should have received along with this software; either version 1.1 of
 * the license, or (at your option) any later version.
 * For a copy of the license or for additional information about this software,
 * write to Xcc Software, Durlacher Allee 53, D-76131 Karlsruhe, Germany;
 * Email: obst@xcc-ka.de.
 * --------------------------------------------------------------------------
 */
#include "obst_err.h"

extern const err_msg err_STF_USAGE;
extern const err_msg err_STF_NO_FILE;
extern const err_msg err_STF_NO_GRAMMAR;
extern const err_msg err_STF_LEXICAL_ERROR;
extern const err_msg err_STF_NO_TYPE;
extern const err_msg err_STF_NO_LIST_TYPE;
extern const err_msg err_STF_NO_CLASS;
extern const err_msg err_STF_NO_SYMBOL;
extern const err_msg err_STF_NO_COMP;
extern const err_msg err_STF_NO_SCHEMA;
extern const err_msg err_STF_NO_GRAMMAR;
extern const err_msg err_STF_OUTPUT_ERROR;
extern const err_msg err_STF_INCOMPATIBLE_TYPES;
extern const err_msg err_STF_AMBIGUOUS_FLATTENING;

#endif
